<?php
//******************************* Lizenzbestimmungen *******************************//
//                                                                                  //
//  Der Quellcode dieses Forums ist urheberrechtlich geschtzt.                     //
//  Bitte beachten Sie die AGB auf www.frank-karau.de/agb.php                       //
//                                                                                  //
//  Dieser Lizenzhinweis darf nicht entfernt werden.                                //
//                                                                                  //
//  (C) phpFK - Forum ohne MySQL - www.frank-karau.de - support@frank-karau.de      //
//                                                                                  //
//**********************************************************************************//

$robots_index = true;
$ITEMS_PER_PAGE = 20;

require_once './include/init.php';

if (!((file_exists('./data/'.$_GET['board'].'/')) && (is_numeric($_GET['board']))))
{
	$MSG_ERROR = $_TEXT['ERROR_BOARD'];
	require './include/page_top.php';
	require './include/page_bottom.php';
	Exit;
}

auth('auth_read');

$_BOARD = IniLoad('./data/'.$_GET['board'].'/board.ini');

$_SUBNAV = array_merge($_SUBNAV, GetBoardParents($_GET['board']));
$_SUBNAV[] = array($_BOARD['title'], url('board.php', $_GET['board']), 'boardS.png');
$_SUBNAV_BOTTOM = $_BOARD['description'];

require './include/page_top.php';

$show = false;
$string = '<div class="content"><table class="main"><tr><td class="oben" colspan="3">'.$_TEXT['BOARDS'].'</td></tr>';
$class = 'g';
foreach(Group2Array($_BOARDS['b'.$_GET['board'].'_children']) as $item)
{
	if (substr($item, 0, 1) == 'b')
	{
		$board = substr($item, 1, 100);
		if (is_numeric($board))
			if (auth('auth_show', false, $board))
			{
				$string .= PreviewBoard($board, $class, $user_in_board[$board], $guests_in_board[$board]);
				$class = ($class == 'g'?'w':'g');
				$show = true;
			}
	}
}
$string .= '</table></div>';
if ($show) echo $string;



$OPTIONS = '
	<div class="dropdown">
		<ul>
			<li><a href="'.url('post.php?do=newthread&board='.$_GET['board']).'"><img src="styles/'.$_FORUM['settings_design_style'].'/images/btn_answer.png" border="0" style="vertical-align:middle;"> '.$_TEXT['NEW_TOPIC'].'</a></li>
';
			if (IsUser())
			{
				if (IsInGroup($_BOARD['notification'], $_SESSION['Benutzername']))
				{
					$OPTIONS .= '<li><a href="'.url('do.php?board='.$_GET['board'].'&do=notification_board_off').'"><img src="./styles/'.$_FORUM['settings_design_style'].'/images/btn_notification_on.png" border="0" style="vertical-align:middle;"> '.$_TEXT['NOTIFICATION_OFF'].'</a></li>';
				}	
				else
				{
					$OPTIONS .= '<li><a href="'.url('do.php?board='.$_GET['board'].'&do=notification_board_on').'"><img src="./styles/'.$_FORUM['settings_design_style'].'/images/btn_notification_off.png" border="0" style="vertical-align:middle;"> '.$_TEXT['NOTIFICATION_ON'].'</a></li>';
				}
			}
$OPTIONS .= '
				</ul>
			</div>
';



$inis = LoadFileList('./data/'.$_GET['board'].'/', '.txt.ini');
$items = array();

$_SESSION['new_posts_board_'.$_GET['board']] = 0;

foreach ($inis as $ini)
{
	$item = IniLoad('./data/'.$_GET['board'].'/'.$ini);
	$item['id'] = str_replace('.txt.ini', '', $ini);
	$item['sortid'] = $item['lastpost_date'];
	$item['new'] = (($item['lastpost_date'] > $_SESSION['new_posts_date']) && ($_SESSION['new_posts_date'] <> '') && (!IsInGroup($_SESSION['new_posts_seen'], $_GET['board'].'_'.$item['id'])));
	if ($item['new']) $_SESSION['new_posts_board_'.$_GET['board']]++;
	if ($item['pin']) $item['sortid'] = $item['sortid'] + 10000000000;
	array_push($items, $item);
}

if ($_SESSION['new_posts_board_'.$_GET['board']] == 0) 
{
	AddToGroup($_SESSION['new_posts_boards_seen'], $_GET['board']);
}
else
{
	DeleteFromGroup($_SESSION['new_posts_boards_seen'], $_GET['board']);
}

function selfsort($a, $b) {
   return ($a['sortid'] < $b['sortid']) ? 1 : -1;
}

usort($items, 'selfsort');

echo '
	<div id="content">
	<table class="main">
	<tr>
		<td class="oben" colspan="3">'.$_TEXT['TOPICS'].'</td>
		'.($_BOARD['auth_rating']!=''?'<td class="oben">'.$_TEXT['RATING'].'</td>':'').'
		<td class="oben">'.$_TEXT['LAST_POST'].'</td>
	</tr>
	<tr>
		<td class="tb" colspan="'.($_BOARD['auth_rating']!=''?'4':'3').'" style="padding:0px;">'.$OPTIONS.'</td>
		<td class="tb" colspan="1" style="text-align:right;">
';

if (($_GET['page'] == '') && ($_GET['board'] == $_SESSION['last_board'])) $_GET['page'] = $_SESSION['last_board_page'];
$pages = ceil(count($items)/$ITEMS_PER_PAGE);
if ($_GET['page']>$pages) $_GET['page']=$pages;
if ($_GET['page']<1) $_GET['page']=1;

if (count($items) > 0) show_pages_($pages, $_GET['page'], 'board.php', $_GET['board']);

$_SESSION['last_board_page'] = $_GET['page'];
$_SESSION['last_board'] = $_GET['board'];

echo '
		</td>
	</tr>
';

$von = ($_GET['page']-1)*$ITEMS_PER_PAGE;
$bis = ($_GET['page']*$ITEMS_PER_PAGE)-1;
if ($bis>=count($items)) $bis=count($items)-1;

$color='g';

for ($i=$von; $i<=$bis; $i++)
{
	$item = $items[$i];
	echo '
		<tr>
			<td class="'.$color.'" style="width:5%; text-align:center;"><a href="'.url('thread.php',$_GET['board'], $item['id']).'"><img src="styles/'.$_FORUM['settings_design_style'].'/images/';
				if ($item['new'])
					echo 'thema_new.png';
				else if (($item['tag'] <> '') AND (file_exists('styles/'.$_FORUM['settings_design_style'].'/images/thema_tag.png')))
					echo 'thema_tag.png';
				else if ($item['lock'])
					echo 'thema_lock.png';
				else if ($item['pin']) 
					echo 'thema_pin.png';
				elseif ($item['answers']>9) 
					echo 'thema_popular.png';
				else
					echo 'thema.png';
				echo '" border="0" alt="'.$item['title'].'"></a>
			</td>
			<td class="'.$color.'" style="width:auto;">'.($item['tag'] <> ''?'<font class="tag">[ '.$item['tag'].' ]</font> ':'').($item['pin']?'<b>':'').'<a href="'.url('thread.php',$_GET['board'], $item['id']).'">'.$item['title'].'</a>'.($item['pin']?'</b>':'').'
	';
				if ($item['answers']>9)
				{
					echo ' <nobr>[';
					show_pages_(ceil((($item['answers']+1)/10)), 0,'thread.php', $_GET['board'], $item['id']);
					echo '&nbsp;]</nobr>';
				}
	echo '
				<p class="sub" style="margin-top:8px;">'.$_TEXT['BY'].' '.user($item['author']).' | '.$_TEXT['ANSWERES'].': '.fnum($item['answers']).' | '.$_TEXT['VIEWS'].': '.fnum($item['views']).'
	';
				if (($user_in_thema[$item['id']][0] != '') || ($guests_in_thema[$item['id']] > 0))
				{	
					echo '<br /><img src="./styles/'.$_FORUM['settings_design_style'].'/images/usersS.png" alt="" /> <b>'.$_TEXT['STAT_NOW_ONLINE'].':</b> ';

					foreach($user_in_thema[$item['id']] as $user) 
					{
						if ($user != $user_in_thema[$item['id']][0]) echo ', '; 
						echo user($user);
					}

					if ($guests_in_thema[$item['id']] > 0)

					{

						if ($user != $user_in_thema[$item['id']][0]) {echo ' '.$_TEXT['STAT_AND'].' ';}
						if ($guests_in_thema[$item['id']] == 1)
						{
							echo $guests_in_thema[$item['id']].' '.$_TEXT['STAT_GUEST'];
						}
						else
						{
							echo $guests_in_thema[$item['id']].' '.$_TEXT['STAT_GUESTS'];
						}
					}
				}
	echo '
			</p></td>
			<td class="'.$color.'" style="text-align:right;">
	';
				if ($item['attachment']) echo '<img src="styles/'.$_FORUM['settings_design_style'].'/images/downloadS.png" border="0" alt="'.$_TEXT['UPLOAD_ATT'].'" />&nbsp;';
				if ($item['poll']) echo '<img src="styles/'.$_FORUM['settings_design_style'].'/images/pollS.png" border="0" alt="'.$_TEXT['POLL'].'" />&nbsp;';
				if (($_SESSION['Benutzername'] <> '') && (IsInGroup($item['notification'], $_SESSION['Benutzername'])))
					echo '<img src="styles/'.$_FORUM['settings_design_style'].'/images/mailS.png" border="0" alt="'.$_TEXT['EMAIL_NOTIFICATION'].'" />&nbsp;';
	echo '
			</td>
	';
	if ($_BOARD['auth_rating'] != '')
	{
		$rating_width = '0px';
		$rating_text = '';
		if ($item['rating_count'] > 0)
		{
			$avarage = $item['rating_points'] / $item['rating_count'];
			$rating_width = number_format(14*$avarage, 2).'px';
			$rating_text = MultiReplace($_TEXT['RATING_TEXT'], $item['rating_count'], number_format($avarage, 2, '.', ','));		
		}
		echo '
			<td class="'.$color.'" style="width:70px;" title="'.$rating_text.'">
				<ul class="rating-view">
					<li class="current-rating-view" style="width:'.$rating_width.'" title="'.$rating_text.'">&nbsp;</li>
				</ul>
			</td>
		';
	}
	echo '
			<td class="'.$color.'" style="width:35%;"><a href="'.url('thread.php', $_GET['board'], $item['id'], $item['answers']).'" title="'.$item['lastpost_title'].'"><img src="styles/'.$_FORUM['settings_design_style'].'/images/gotoS.png" border="0" alt="'.$_TEXT['LAST_POST'].'"></a> <a href="'.url('thread.php', $_GET['board'], $item['id'], $item['answers']).'" title="'.$item['lastpost_title'].'">'.($item['lastpost_title']<>''?$item['lastpost_title']:'...').'</a><p class="sub">'.ftime($item['lastpost_date']).' '.$_TEXT['BY'].' '.user($item['lastpost_from']).'</p></td>
		</tr>
	';
	$color = ($color=='g'?'w':'g');
	if ($i == $von)
	{
		if (file_exists('data/advertising_boardafter1.txt'))
		{
			echo '
				<tr><td class="'.$color.'" colspan="'.($_BOARD['auth_rating']!=''?'5':'4').'">
					'.file_get_contents('data/advertising_boardafter1.txt').'
				</td></tr>
			';
			$color = ($color=='w'?'g':'w');
		}
	}
	if ((($von-$i+4) % 5 == 0) && ($i <> $bis))
	{
		if (file_exists('data/advertising_boardevery5.txt'))
		{
			echo '
				<tr><td class="'.$color.'" colspan="'.($_BOARD['auth_rating']!=''?'5':'4').'">
					'.file_get_contents('data/advertising_boardevery5.txt').'
				</td></tr>
			';
			$color = ($color=='w'?'g':'w');
		}
	}

}

if (count($items) > 0)
{
	echo '
	  <tr>
		<td class="tb" colspan="'.($_BOARD['auth_rating']!=''?'4':'3').'" style="padding:0px;">'.$OPTIONS.'</td>
		<td class="tb" colspan="1" style="text-align:right;">
	';

	show_pages_($pages, $_GET['page'], 'board.php', $_GET['board']);
	
	echo '
			</td>
	  </tr>
	';
}
echo '
	</table>
	</div>
';

require './include/page_bottom.php';
?>