<?php
//******************************* Lizenzbestimmungen *******************************//
//                                                                                  //
//  Der Quellcode dieses Forums ist urheberrechtlich geschtzt.                     //
//  Bitte beachten Sie die AGB auf www.frank-karau.de/agb.php                       //
//                                                                                  //
//  Dieser Lizenzhinweis darf nicht entfernt werden.                                //
//                                                                                  //
//  (C) phpFK - Forum ohne MySQL - www.frank-karau.de - support@frank-karau.de      //
//                                                                                  //
//**********************************************************************************//

require_once './include/init.php';

//* Header *//
$title = '';
$add_description = $_FORUM['settings_forum_description'];
$add_keywords = $_FORUM['settings_forum_keywords'];
if ((auth('auth_read', false)) && ($_GET['board'] <> ''))
{
	$_BOARD = IniLoad('./data/'.$_GET['board'].'/board.ini');
	$title = '';
	foreach(GetBoardParents($_GET['board']) as $item)
	{
		$title .= $item[0].' &raquo; ';
	}
	$title .= $_BOARD['title'];
	if (file_exists('./data/'.$_GET['board'].'/'.$_GET['thema'].'.txt'))
	{
		$arr = FileLoad('./data/'.$_GET['board'].'/'.$_GET['thema'].'.txt');
		$title .= ' &raquo; '.$arr[0][2];
		$add_description = history_text($arr[0][2], $arr[0][3], 300);
		// Keywords erzeugen
		$seperator = " <>,.!?:'\"_#+*()\\/\n\r\t";
		$arr_keywords = array();
		$tok = strtok(html_entity_decode(history_text($arr[0][2], $arr[0][3], 1000)), $seperator);
		while ($tok !== false) 
		{
			if (strlen($tok) > 4) array_push($arr_keywords, strtolower($tok));
			$tok = strtok($seperator);
		}
		$arr_keywords = array_unique($arr_keywords);
		$add_keywords = implode(', ', $arr_keywords);
	}
	$title .= ' | '.$_FORUM['settings_forum_name'];
}
else
{
	$url2title = array(
		'reg.php' => $_TEXT['NAV_REGISTER'],
		'logini.php' => $_TEXT['NAV_LOGIN'],
		'ranking.php' => $_TEXT['NAV_RANKING'],
		'search.php' => $_TEXT['NAV_SEARCH'],
		'rules.php' => $_TEXT['NAV_RULES'],
		'faq.php' => $_TEXT['NAV_FAQ'],
		'imprint.php' => $_TEXT['NAV_IMPRESSUM'],
		'login.php' => $_TEXT['LOGIN_LOGIN'],
		'whoisonline.php' => $_TEXT['NAV_WHOISONLINE'],
		'user.php' => $_TEXT['PROFILE'].': '.$user
	);
	$title = ($url2title[basename($_SERVER['SCRIPT_NAME'])] <> ''?$url2title[basename($_SERVER['SCRIPT_NAME'])].' | ':'').$_FORUM['settings_forum_name'];
}

	$highlight_keys = array();
	$ref = utf8_decode(urldecode(parse_url($_SERVER['HTTP_REFERER'], PHP_URL_QUERY)));
	$keystring = '';
	if ($ref != '')
	{
		foreach(explode('&',$ref) as $item)
		{
			$items = explode('=',$item);
			if (in_array($items[0], array('p','q','s','query')))
			{
				$keystrings = $items[1];
				Break;
			}
		}
		if ($keystrings != '')
		{
			$tok = strtok($keystrings, " +");
			while ($tok !== false) 
			{
			    	if (strlen($tok)>1) $highlight_keys[] = $tok;
			    	$tok = strtok(" +");
			}	
			
		}
	}

echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" 
	"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<meta http-equiv="Content-Style-Type" content="text/css">
	<meta http-equiv="Content-Script-Type" content="text/javascript">
	<meta http-equiv="cache-control" content="no-cache">
	<meta name="Author" content="Frank Karau - www.frank-karau.de">
	<meta name="Keywords" content="'.$add_keywords.'">
	<meta name="Description" content="'.$add_description.'">
	<meta name="Software" content="phpFK www.frank-karau.de - PHP-Forum '.$_FORUM['version'].'">
	'.($_FORUM['settings_system_shorturls']?'<base href="'.$_FORUM['settings_forum_url'].'/">':'').'
	'.(!$robots_index?'<meta name="robots" content="noindex, follow">':'').'
	<title>'.$title.'</title>
	'.(file_exists('styles/'.$_FORUM['settings_design_style'].'/head.html')?style_convert(file_get_contents('./styles/'.$_FORUM['settings_design_style'].'/head.html')):'').'
	'.($_FORUM['settings_design_rss']?'<link rel="alternate" type="application/atom+xml" title="'.$_FORUM['settings_forum_name'].'" href="'.$_FORUM['settings_forum_url'].'/rss.php">':'').'
	<link rel="stylesheet" type="text/css" href="styles/'.$_FORUM['settings_design_style'].'/text.css">
	<link rel="stylesheet" type="text/css" href="include/forum.css">
	<link rel="icon" href="'.($_FORUM['settings_system_shorturls']?$_FORUM['settings_forum_url'].'/':'').'styles/'.$_FORUM['settings_design_style'].'/favicon.ico" type="image/x-icon"> 
	<link rel="shortcut icon" href="'.($_FORUM['settings_system_shorturls']?$_FORUM['settings_forum_url'].'/':'').'styles/'.$_FORUM['settings_design_style'].'/favicon.ico" type="image/x-icon"> 
	<script type="text/javascript" src="include/scripts.js"></script>
	<script type="text/javascript" src="include/codepress/codepress.js"></script>
	<script type="text/javascript" src="../struttura/js/jquery.js"></script>
	<script type="text/javascript" src="include/slimbox/slimbox2.js"></script>
	<link rel="stylesheet" href="include/slimbox/slimbox2.css" type="text/css" media="screen" />
</head>
<body onLoad="preload();'.(count($highlight_keys)>0?'Highlight(\''.implode(' ',$highlight_keys).'\');':'').$BODY_ONLOAD.'">
';

if (in_array(basename($_SERVER['PHP_SELF']), array('my_profil.php', 'ranking.php', 'search.php', 'rules.php', 'faq.php', 'impressum.php', 'post.php')))
	$url = url(basename($_SERVER['PHP_SELF']).($_SERVER['QUERY_STRING']<>''?'?'.$_SERVER['QUERY_STRING']:''));
else if (in_array(basename($_SERVER['PHP_SELF']), array('thread.php', 'board.php')))
	$url = url(basename($_SERVER['PHP_SELF']), $_GET['board'], $_GET['thema'], ($_GET['page']*10)-1);
else if (in_array(basename($_SERVER['PHP_SELF']), array('user.php')))
	$url = url(basename($_SERVER['PHP_SELF']), $_GET['user']);
else
	$url = url('index.php');

echo '
	<div id="login-panel">
		<form action="'.$url.'" name="login" method="post">
		<table width="100%" cellspacing="0">
			<tr><td><img src="./styles/'.$_FORUM['settings_design_style'].'/images/loginS.png" alt="'.$_TEXT['LOGIN_LOGIN'].'"> <b>'.$_TEXT['LOGIN_LOGIN'].'</b></td><td></td><td style="text-align:right;"><a href="Javascript:hidePanel();">'.$_TEXT['CLOSE_WINDOW'].'</a></td></tr>
			<tr><td><input type="hidden" name="action" value="login" /><label for="name">'.$_TEXT['LOGIN_USERNAME'].':</label> <input type="text" id="name" NAME="name" value="'.$_COOKIE['loginname'].'"></td><td><label for="passwd">'.$_TEXT['LOGIN_PASSWORD'].':</label> <input type="password" name="passwd" id="passwd"></td><td><input type="submit" name="submit" value="'.$_TEXT['LOGIN_LOGIN'].'"></td></tr>
			<tr><td colspan="3"><input type="checkbox" name="cookie" checked="checked" id="cookie"> <label for="cookie">'.$_TEXT['LOGIN_COOKIE'].'</label> | <a href="'.url('login.php').'">'.$_TEXT['LOGIN_LOST_PASSWORD'].'</a></td></tr>
		</table>
		</form>
	</div>
';

if ($_FORUM['settings_loading'] == 'off')
{
	echo '<div id="loadingbox" style="visibility:none;height:0;width:0;"></div>';
}
else
{
	echo '
		<div id="loadingbox" class="'.($_FORUM['settings_loading']=='premium'?'premium':'').'" style="display:none; align:center; vertical-align:middle;" align="center">
			<table style="position:relative; top:40%; width:250px; height:125px; background:#FFFFFF;"><tr><td style="background: #fff url(images/loading.gif) no-repeat center;">&nbsp;</td></tr></table>
		</div>
	';
}

ob_start();
@include('./styles/'.$_FORUM['settings_design_style'].'/top.php');
@include('./styles/'.$_FORUM['settings_design_style'].'/top.html');
$content = ob_get_contents();
ob_end_clean();
echo style_convert($content);

@include('data/advertising_top.txt');

//* Status: Offline *//
if (!$_FORUM['status'])
{
	echo '<div id="error"><b>'.$_TEXT['FORUM_OFFLINE'].':</b><br />';
	$file = file('./data/offline.txt');
	foreach($file as $line)
	{
		if ($line <> $file[0]) echo '<br />';
		echo do_ubb($line);
	}
	echo '</div>';
	if  (!IsAdmin($_SESSION['Benutzername']))
	{
		require './include/page_bottom.php';
		Exit;
	}
}

//* Subnavigation *//
echo '
	<div class="subnav">
	  <table><tr>
		<td><a href="'.url('index.php').'"><img src="styles/'.$_FORUM['settings_design_style'].'/images/homeS.png" border="0" alt="'.$_FORUM['settings_forum_name'].'" style="vertical-align:middle;"></a>&nbsp;<a href="'.url('index.php').'" title="'.$_FORUM['settings_forum_name'].'">'.$_TEXT['FORUM'].'</a>
';
foreach ($_SUBNAV as $item)
{
	// 0=Text | 1=URL | 2=IMG | 3=TAG
	echo '&raquo;&nbsp;';
//	if (file_exists('styles/'.$_FORUM['settings_design_style'].'/images/'.$item[2]) && ($item[2]<>''))
//		echo ($item[1]<>''?'<a href="'.$item[1].'">':'').'<img src="styles/'.$_FORUM['settings_design_style'].'/images/'.$item[2].'" border="0" alt="'.$item[0].'" style="vertical-align:middle;">'.($item[1]<>''?'</a>':'').'&nbsp;';
	if ($item[3] <> '') echo '<font class="tag">[ '.$item[3].' ]</font> ';
	echo ($item[1]<>''?'<a href="'.$item[1].'">':'').$item[0].($item[1]<>''?'</a>':'').' ';
}
if ($_SUBNAV_BOTTOM <> '')
{
	echo '<p class="sub">'.$_SUBNAV_BOTTOM.'</p>';
}
echo '
		</td>
';
if ($_SUBNAV_RIGHT <> '')
{
	echo '
		<td style="text-align:right;">'.$_SUBNAV_RIGHT.'</td>
	';
}
echo '
	  </tr></table>
	</div>
';




GLOBAL $MSG_ERROR, $MSG_NOTICE, $MSG_CONFIRM;
if ($MSG_ERROR <> '')
	echo '<div id="error">'.$MSG_ERROR.'</div>';

if ($MSG_NOTICE <> '')
	echo '<div id="notice">'.$MSG_NOTICE.'</div>';

if ($MSG_CONFIRM <> '')
	echo '<div id="confirm">'.$MSG_CONFIRM.'</div>';


if (count($highlight_keys) > 0)
{
	echo '
			<div id="content">
				<table class="main">
				<tr><td class="g">
					'.MultiReplace($_TEXT['SEARCH_HIGHLIGHT'], implode(' ', $highlight_keys)).' [<a href="'.$_SERVER['REQUEST_URI'].'">'.$_TEXT['HIDE'].'</a>]
				</td></tr>
				</table>
			</div>
	';
}

?>