<?php
//******************************* Lizenzbestimmungen *******************************//
//                                                                                  //
//  Der Quellcode dieses Forums ist urheberrechtlich geschtzt.                     //
//  Bitte beachten Sie die AGB auf www.frank-karau.de/agb.php                       //
//                                                                                  //
//  Dieser Lizenzhinweis darf nicht entfernt werden.                                //
//                                                                                  //
//  (C) phpFK - Forum ohne MySQL - www.frank-karau.de - support@frank-karau.de      //
//                                                                                  //
//**********************************************************************************//

require './include/init.php';

$user = CheckVar($_GET['user']);

if (!IsUser($user))
{
	$MSG_ERROR = MultiReplace($_TEXT['ERROR_NO_REG_USER'], '<b>'.$user.'</b>');
	include('./index.php');
	Exit; 
}

$_SUBNAV[] = array($_TEXT['PROFILE'].': '.user($user));

require './include/page_top.php';

if (!IsUser() && defined('CONFIG_PROFILE_SHOW_ONLY_USERS') && CONFIG_PROFILE_SHOW_ONLY_USERS == 1)
{
		echo '
			<div id="error" style="text-align:left;">'.$_TEXT['ACCESS_DENIED_MSG'].'</div>
			<div id="content">
				<form action="'.url($_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING']).'" method="post">
				<input type="hidden" name="action" value="login" />
				<table class="main">
				<tr><td class="oben">'.$_TEXT['LOGIN_LOGIN'].'</td></tr>
				<tr><td class="g">
					<center>
					<table style="width:60%;">
					<tr>
						<td style="text-align:right;"><label for="name">'.$_TEXT['LOGIN_USERNAME'].':</label></td>
						<td><input type="text" id="name" name="name" value="'.$_COOKIE['loginname'].'" maxlength="20" /></td>
					</tr>
					<tr>
						<td style="text-align:right;"><label for="passwd">'.$_TEXT['LOGIN_PASSWORD'].':</label></td>
						<td><input type="password" id="passwd" name="passwd" maxlength="20" />  <a href="'.url('login.php').'">'.$_TEXT['LOGIN_LOST_PASSWORD'].'</a></td>
					</tr>
					<tr>
						<td colspan="2" style="text-align:center;"><input type="checkbox" name="cookie"> '.$_TEXT['LOGIN_COOKIE'].'</td>
					</tr>
					<tr>
						<td colspan="2" style="text-align:center;"><input type="submit" name="submit" value="'.$_TEXT['LOGIN_LOGIN'].'"></td>
					</tr>
					</table>
				</td></tr>
				</table>
				</form>
			</div>
		';
	require './include/page_bottom.php';
	Exit;
}



$data = IniLoad('./data/user/'.$user.'.usr.ini');

// Themen pro Tag
$anz_bei = $data['count_topics'];
$anz_tag = ceil((time()-$data['register_date'])/86400);
$perday = round(($anz_bei*10)/($anz_tag));
$themen_day = ' ('.($perday/10).' '.$_TEXT['A_DAY'].')';

// Antworten pro Tag
$anz_bei = $data['count_answeres'];
$anz_tag = ceil((time()-$data['register_date'])/86400);
$perday = round(($anz_bei*10)/($anz_tag));
$antworten_day = ' ('.($perday/10).' '.$_TEXT['A_DAY'].')';

// Locked in Prozent
if ($data['count_locked']>0) $locked = " (".round($data['count_locked']*100/$data['count_topics'])."%)";

echo '

	<div id="content">
		<table class="main">
		<tr><td class="oben" colspan="2">'.$_TEXT['PROFILE'].': '.user($user).'</td></tr>
		<tr><td class="g" style="vertical-align:top; width:70%;">
			<table class="main">
				<tr><td class="g"><b>'.$_TEXT['LOGIN_USERNAME'].'</b></td><td class="g"><b>'.user($user).'</b></td></tr>
				<tr><td class="w">'.$_TEXT['RANKING'].'</td><td class="w"><b>'.user_points($user).' '.$_TEXT['POINTS'].'</b></td></tr>
				<tr><td class="g">&nbsp;&nbsp;&nbsp;'.$_TEXT['TOPICS'].'</td><td class="g">'.$data['count_topics'].$themen_day.'</td></tr>		
				<tr><td class="w">&nbsp;&nbsp;&nbsp;'.$_TEXT['ANSWERES'].'</td><td class="w">'.$data['count_answeres'].$antworten_day.'</td></tr>
				<tr><td class="g">&nbsp;&nbsp;&nbsp;'.$_TEXT['LOCKED_TOPICS'].'</td><td class="g">'.$data['count_locked'].$locked.'</td></tr>
				<tr><td class="w">'.$_TEXT['TIME_OF_REGISTRATION'].'</td><td class="w">'.ftime($data['register_date']).'</td></tr>
				<tr><td class="g">'.$_TEXT['TIME_OF_LAST_VISIT'].'</td><td class="g">'.ftime($data['lastonline_date']).'</td></tr>

				'.(trim($data['text'])!=""?'<tr><td class="w">'.$_TEXT[PROFILE_DATA_TEXT].'</td><td class="w">'.$data['text'].'</td></tr>':'').'
			</table>

			<table class="main">
';


// at: sonstige Angaben
$list = array();
$class = "w";
foreach ($list as $line)
{
	$class = ($class=='w'?'g':'w');
	echo '
			<tr>
				<td class="'.$class.'">'.$line[0].'</td>
				<td class="'.$class.'">'.$line[1].'</td>
			</tr>
	';
}

echo '
			</table>

		</td><td class="g" style="vertical-align:top; width:30%;">
			<table class="main">
			<tr><td class="g"><b>'.$_TEXT['PROFILE_AVATAR'].'</b></td></tr>
			<tr><td class="w" style="text-align:center;">
';
				if ($data['avatar'] !="") { echo '<img src="'.$data['avatar'].'" border="0" >';} else { echo '-'; }
echo '
			</td></tr>
			</table>
			&nbsp;<table class="main">
';

$list = array();

// Nachricht
if ($_SESSION['Benutzername'] <> '')
{
	array_push($list, array($_TEXT['EMAIL'], '<a href="my_profile_mail.php?user='.$user.'"><img src="styles/'.$_FORUM['settings_design_style'].'/images/mailS.png" style="vertical-align:bottom;" border="0" alt="'.$_TEXT['SEND_EMAIL'].'"></a> <a href="my_profile_mail.php?user='.$user.'">'.$_TEXT['SEND_EMAIL'].'</a>'));
	if ($data['show_email']) array_push($list, array($_TEXT['EMAIL'], '<a href="mailto:'.format_input($data['email']).'"><img src="styles/'.$_FORUM['settings_design_style'].'/images/mailS.png" style="vertical-align:bottom;" border="0" alt="'.format_input($data['email']).'"></a> <a href="mailto:'.format_input($data['email']).'">'.fhtml($data['email']).'</a>'));
}

// Homepage
if ($data['homepage']!="") 
{
	if (!is_integer(strpos($data['homepage'],"://")))
		$data['homepage'] = 'http://'.$data['homepage'];
	array_push($list, array($_TEXT['HOMEPAGE'], '<a href="'.format_input($data['homepage']).'" target="_blank"><img src="styles/'.$_FORUM['settings_design_style'].'/images/homeS.png" style="vertical-align:bottom;" border="0"  alt="'.$_TEXT['HOMEPAGE'].'"></a> <a href="'.format_input($data['homepage']).'" target="_blank">'.fhtml($data['homepage']).'</a>'));
}

//ICQ
if ($data['icq']<>"")
{
	array_push($list, array($_TEXT['ICQ'], '<a href="http://web.icq.com/whitepages/message_me?uin='.format_input($data['icq']).'&action=message" target="_blank"><img src="http://status.icq.com/online.gif?icq='.$data['icq'].'&img=5" border="0" alt="'.$_TEXT['ICQ'].'" style="width:12px;height:12px;" /></a> <a href="http://web.icq.com/whitepages/message_me?uin='.format_input($data['icq']).'&action=message" target="_blank">'.fhtml($data['icq']).'</a>'));
}

// SKYPE
if ($data['skype']<>"")
{
	array_push($list, array($_TEXT['SKYPE'], '<a href="callto://'.format_input($data['skype']).'"><img src="styles/'.$_FORUM['settings_design_style'].'/images/skypeS.png" style="vertical-align:bottom;" border="0" alt="'.$_TEXT['SKYPE'].'"></a> <a href="callto://'.format_input($data['skype']).'">'.fhtml($data['skype']).'</a>'));
}


// MSN
if ($data['msn']<>"")
{
	array_push($list, array($_TEXT['MSN'], '<a href="http://members.msn.com/?mem='.format_input($data['msn']).'" target="_blank"><img src="styles/'.$_FORUM['settings_design_style'].'/images/msnS.png" border="0" alt="'.$_TEXT['MSN'].'"></a> <a href="http://members.msn.com/?mem='.format_input($data['msn']).'" target="_blank">'.fhtml($data['msn']).'</a>'));
}

// AIM
if ($data['aim']<>"")
{
	array_push($list, array($_TEXT['AIM'], '<a href="aim:GoIM?screenname='.format_input($data['aim']).'" target="_blank"><img src="styles/'.$_FORUM['settings_design_style'].'/images/aimS.png" border="0" alt="'.$_TEXT['AIM'].'" /></a> <a href="aim:GoIM?screenname='.format_input($data['aim']).'" target="_blank">'.fhtml($data['aim']).'</a>'));
}

// YAHOO
if ($data['yahoo']<>"")
{
	array_push($list, array($_TEXT['YAHOO'], '<a href="http://messenger.yahoo.com/edit/send/?.target='.format_input($data['yahoo']).'"><img src="styles/'.$_FORUM['settings_design_style'].'/images/yahooS.png" border="0" alt="'.$_TEXT['YAHOO'].'" /></a> <a href="http://messenger.yahoo.com/edit/send/?.target='.format_input($data['yahoo']).'">'.fhtml($data['yahoo']).'</a>'));
}

$class = "w";
foreach ($list as $line)
{
	$class = ($class=='w'?'g':'w');
	echo '
			<tr>
				<td class="'.$class.'">'.$line[1].'</td>
			</tr>
	';
}

echo '
			</table>
		</td></tr>
		</table>
	</div>
';

if ($_FORUM['settings_user_guestbook'])
{
	echo '
	<div id="content">
		<table class="main">
		<tr><td class="oben">'.$_TEXT['GUESTBOOK'].'</td></tr>
	';

	$datei = './data/user/'.$user.'.gb';
	
	if ($_POST['submit'] == $_TEXT['GUESTBOOK_SUBMIT'])
	{
		if (IsUser() && (trim($_POST['text']) != ''))
		{
			$line[0] = $_SESSION['Benutzername'];
			$line[1] = time();
			$line[2] = format($_POST['text']);
			FileAppend($datei, $line);
			SendMessage(array($user), $_TEXT['GUESTBOOK'], $_SESSION['Benutzername']." ".$_TEXT['MSG_WROTE_GUESTBOOK']."\n------------------------------\n".$_POST['text']);
		}
	}
	
	//Lschen
	if (($_GET['submit'] == 'del') && (($user == $_SESSION['Benutzername']) OR IsAdmin($_SESSION['Benutzername'])))
	{
		FileDeleteLine($datei, $_GET['del']);
	}
	
	$eintrag = FileLoad($datei);
	$gesamt = count($eintrag);
	$pages = ceil(($gesamt)/5);
	if ($pages == 0) $pages=1;
	if ($page>$pages) $page=$pages;
	if ($page<"1") $page="1";
	

	
	if ($gesamt == 0)
	{ 
		echo '<tr><td class="w">'.$_TEXT['GUESTBOOK_NO_ENTRIES'].'</td></tr>';
	}
	else
	{
		$page = $_GET['page'];
		if ($page < 1) $page=1;
		$eintrag = array_reverse($eintrag);
		$von = (($page-1)*5);
		$bis = ($page*5);
		if ($von<1) $von=0;
		if ($bis>$gesamt) $bis=$gesamt;
		for ($i=$von; $i<$bis; $i++)
		{
			$gdat = $eintrag[$i];
			echo '
				<tr><td class="w">
					<p class="sub">'.ftime($gdat[1]).' '.$_TEXT['FROM'].' '.user($gdat[0]).((($user == $_SESSION['Benutzername']) OR IsAdmin($_SESSION['Benutzername']))?' [<a href="'.url('user.php?user='.$user.'&page='.$page.'&submit=del&del='.($gesamt-$i-1)).'">'.$_TEXT['DELETE'].'</a>]':'').'</p>
					<p style="margin-left:10px;margin-top:3px;">"<i>'.$gdat[2].'</i>"</p>
				</td></tr>
			';
		}

		echo "<tr><td class=\"w\"><img src=styles/".$_FORUM['settings_design_style']."/images/gotoS.png border=0>";
		for ($i="1";$i<($pages+1);$i++)
		{
		 if ($i==$page)
		  echo "$i&nbsp;";
		 else
		  echo "<a href=user.php?user=$user&page=$i>$i</a>&nbsp;";
		}
		if ($page!=$pages) echo "<a href=user.php?user=$user&page=".($page+1).">&raquo;</a>";
		echo '</td></tr>';
	}

	if (IsUser())
	{
	echo '
		<tr>
			<td class="g">
				<fieldset style="width:400px;">
				<legend>'.$_TEXT['GUESTBOOK_SUBMIT'].'</legend>
				<form action="user.php?user='.$user.'&page=1" method="post" name="gbook">
				<table style="width:100%;">
				<tr>
					<td style="width:20%;">'.$_TEXT['GUESTBOOK_USERNAME'].':</td>
					<td style="width:80%;"><b>'.$_SESSION['Benutzername'].'<b></td>
				</tr>
				<tr>
					<td style="vertical-align:top;">'.$_TEXT['GUESTBOOK_TEXT'].':</td>
					<td><TEXTAREA  NAME="text" style="width:100%;" ROWS="7" COLS="25"></TEXTAREA></td>
				</tr>
				<tr>
					<td colspan="2" style="text-align:center;"><INPUT TYPE="SUBMIT" NAME="submit" VALUE="'.$_TEXT['GUESTBOOK_SUBMIT'].'"></td>
				</tr>
				</table>
				</form>
				</fieldset>
			</td>
		</tr>
	';
	}
	echo '
		</table>
	</div>
	';
}

require './include/page_bottom.php';  
?>