<?php
/* Articoli Blog in formato RSS */

    function EncodeISO($textin,$code) {
      if ($code == "iso-8859-1") {
        $textout = htmlentities(htmlspecialchars(strip_tags(html_entity_decode($textin,ENT_QUOTES)),ENT_QUOTES),ENT_QUOTES);
        $textout = str_replace("&nbsp;",  "&#160;",$textout);
        $textout = str_replace("&iexcl;", "&#161;",$textout);
        $textout = str_replace("&cent;",  "&#162;",$textout);
        $textout = str_replace("&pound;", "&#163;",$textout);
        $textout = str_replace("&curren;","&#164;",$textout);
        $textout = str_replace("&yen;",   "&#165;",$textout);
        $textout = str_replace("&brvbar;","&#166;",$textout);
        $textout = str_replace("&sect;",  "&#167;",$textout);
        $textout = str_replace("&uml;",   "&#168;",$textout);
        $textout = str_replace("&copy;",  "&#169;",$textout);
        $textout = str_replace("&ordf;",  "&#170;",$textout);
        $textout = str_replace("&laquo;", "&#171;",$textout);
        $textout = str_replace("&not;",   "&#172;",$textout);
        $textout = str_replace("&shy;",   "&#173;",$textout);
        $textout = str_replace("&reg;",   "&#174;",$textout);
        $textout = str_replace("&macr;",  "&#175;",$textout);
        $textout = str_replace("&deg;",   "&#176;",$textout);
        $textout = str_replace("&plusmn;","&#177;",$textout);
        $textout = str_replace("&sup2;",  "&#178;",$textout);
        $textout = str_replace("&sup3;",  "&#179;",$textout);
        $textout = str_replace("&acute;", "&#180;",$textout);
        $textout = str_replace("&micro;", "&#181;",$textout);
        $textout = str_replace("&para;",  "&#182;",$textout);
        $textout = str_replace("&middot;","&#183;",$textout);
        $textout = str_replace("&cedil;", "&#184;",$textout);
        $textout = str_replace("&sup1;",  "&#185;",$textout);
        $textout = str_replace("&ordm;",  "&#186;",$textout);
        $textout = str_replace("&raquo;", "&#187;",$textout);
        $textout = str_replace("&frac14;","&#188;",$textout);
        $textout = str_replace("&frac12;","&#189;",$textout);
        $textout = str_replace("&frac34;","&#190;",$textout);
        $textout = str_replace("&iquest;","&#191;",$textout);
        $textout = str_replace("&Agrave;","&#192;",$textout);
        $textout = str_replace("&Aacute;","&#193;",$textout);
        $textout = str_replace("&Acirc;", "&#194;",$textout);
        $textout = str_replace("&Atilde;","&#195;",$textout);
        $textout = str_replace("&Auml;",  "&#196;",$textout);
        $textout = str_replace("&Aring;", "&#197;",$textout);
        $textout = str_replace("&AElig;", "&#198;",$textout);
        $textout = str_replace("&Ccedil;","&#199;",$textout);
        $textout = str_replace("&Egrave;","&#200;",$textout);
        $textout = str_replace("&Eacute;","&#201;",$textout);
        $textout = str_replace("&Ecirc;", "&#202;",$textout);
        $textout = str_replace("&Euml;",  "&#203;",$textout);
        $textout = str_replace("&Igrave;","&#204;",$textout);
        $textout = str_replace("&Iacute;","&#205;",$textout);
        $textout = str_replace("&Icirc;", "&#206;",$textout);
        $textout = str_replace("&Iuml;",  "&#207;",$textout);
        $textout = str_replace("&ETH;",   "&#208;",$textout);
        $textout = str_replace("&Ntilde;","&#209;",$textout);
        $textout = str_replace("&Ograve;","&#210;",$textout);
        $textout = str_replace("&Oacute;","&#211;",$textout);
        $textout = str_replace("&Ocirc;", "&#212;",$textout);
        $textout = str_replace("&Otilde;","&#213;",$textout);
        $textout = str_replace("&Ouml;",  "&#214;",$textout);
        $textout = str_replace("&times;", "&#215;",$textout);
        $textout = str_replace("&Oslash;","&#216;",$textout);
        $textout = str_replace("&Ugrave;","&#217;",$textout);
        $textout = str_replace("&Uacute;","&#218;",$textout);
        $textout = str_replace("&Ucirc;", "&#219;",$textout);
        $textout = str_replace("&Uuml;",  "&#220;",$textout);
        $textout = str_replace("&Yacute;","&#221;",$textout);
        $textout = str_replace("&THORN;", "&#222;",$textout);
        $textout = str_replace("&szlig;", "&#223;",$textout);
        $textout = str_replace("&agrave;","&#224;",$textout);
        $textout = str_replace("&aacute;","&#225;",$textout);
        $textout = str_replace("&acirc;", "&#226;",$textout);
        $textout = str_replace("&atilde;","&#227;",$textout);
        $textout = str_replace("&auml;",  "&#228;",$textout);
        $textout = str_replace("&aring;", "&#229;",$textout);
        $textout = str_replace("&aelig;", "&#230;",$textout);
        $textout = str_replace("&ccedil;","&#231;",$textout);
        $textout = str_replace("&egrave;","&#232;",$textout);
        $textout = str_replace("&eacute;","&#233;",$textout);
        $textout = str_replace("&ecirc;", "&#234;",$textout);
        $textout = str_replace("&euml;",  "&#235;",$textout);
        $textout = str_replace("&igrave;","&#236;",$textout);
        $textout = str_replace("&iacute;","&#237;",$textout);
        $textout = str_replace("&icirc;", "&#238;",$textout);
        $textout = str_replace("&iuml;",  "&#239;",$textout);
        $textout = str_replace("&eth;",   "&#240;",$textout);
        $textout = str_replace("&ntilde;","&#241;",$textout);
        $textout = str_replace("&ograve;","&#242;",$textout);
        $textout = str_replace("&oacute;","&#243;",$textout);
        $textout = str_replace("&ocirc;", "&#244;",$textout);
        $textout = str_replace("&otilde;","&#245;",$textout);
        $textout = str_replace("&ouml;",  "&#246;",$textout);
        $textout = str_replace("&divide;","&#247;",$textout);
        $textout = str_replace("&oslash;","&#248;",$textout);
        $textout = str_replace("&ugrave;","&#249;",$textout);
        $textout = str_replace("&uacute;","&#250;",$textout);
        $textout = str_replace("&ucirc;", "&#251;",$textout);
        $textout = str_replace("&uuml;",  "&#252;",$textout);
        $textout = str_replace("&yacute;","&#253;",$textout);
        $textout = str_replace("&thorn;", "&#254;",$textout);
        $textout = str_replace("&yuml;",  "&#255;",$textout);
      }
      return $textout;
    }

    $xml  = "<?xml version=\"1.0\" encoding=\"$CharSet\"?>\n";
    $xml .= "<rss version=\"2.0\">\n";
    $xml .= "<channel>\n";
    $xml .= "<title>".EncodeISO($sito[0]." - Blog",$CharSet)."</title>\n";
    $xml .= "<link>".$sito[2]."</link>\n";
    $xml .= "<description>".EncodeISO($meta[8],$CharSet)."</description>\n";
    $xml .= "<docs>http://vaniarupeni.altervista.org/</docs>\n";
    $xml .= "<generator>New-CMS</generator>\n";
    $xml .= "<copyright>".EncodeISO($meta[6],$CharSet)."</copyright>\n";
    $xml .= "<language>".$lng."</language>\n";
    $oggi = date("D, d M Y H:i:s +0100");
    $xml .= "<pubDate>".date("r",$data)."</pubDate>\n";

$listcat = lista(CBLG."cat".DTB);
for($ic=0;$ic<count($listcat);$ic++){
$dbcat=dblin($listcat[$ic]);
$DBCAT=explode("||",$dbcat[0]);
$ncat[$ic] = $dbcat[1];
if($DBCAT[$LNG]!="") { $dcat[$ic] = $DBCAT[$LNG]; } else {   $dcat[$ic] = $DBCAT[0]; }
}

$file = ListaFile(CBLG,"d");
for($i=0;$i<count($file);$i++){
$nwf=lista(CBLG.$file[$i]);
$lf=dblin($nwf[0]);
if($lf[7]=="on"&&$file[$i]!="configadmin".DTB&&$file[$i]!="cat".DTB){$lfile[]=$file[$i];}
}
sort($lfile);
$lfile = array_reverse($lfile);

if(count($lfile)<15) { $NNews = count($lfile); } else { $NNews = 15; }

for($i=0;$i<$NNews;$i++){
$DBnews=lista(CBLG.$lfile[$i]);
$nws = dblin($DBnews[$LNG]);
if($nws[5]==""||$nws[6]=="") $nws = dblin($DBnews[0]);
$pos = array_search($cat, $ncat, true);
$cat = $dcat[array_search($nws[0],$ncat,true)];

         $xml .= "<item>\n<title>".EncodeISO($cat." - ".$nws[5],$CharSet)."</title>\n";
         $xml .= "<link>".$sito[2]."index.php?lng=$lng&amp;mod=blog&amp;pg=pagina&amp;doc=".str_replace(DTB,"",$lfile[$i])."</link>\n";
         $xml .= "<author>".EncodeISO($nws[1],$CharSet)."</author>\n";
         $xml .= "<pubDate>".date("r",str_replace(DTB,"",$lfile[$i]))."</pubDate>\n";
         $nws[6] = str_replace("[~n~]","",$nws[6]);
         $nws[6] = strip_tags($nws[6]);
         $nwsA =preg_split("/ /",$nws[6]);
         $des = strip_tags($nwsA[0]);
          $neXt=1;
          while(strlen($des)<285){
          $des .= " ".$nwsA[$neXt];
          if(count($nwsA)==$neXt) break;
          $neXt++;
          }
         if(strlen($des)<strlen($nws[3])){
         $xml .= "<description>".EncodeISO($des,$CharSet)." ...</description>\n";
         } else {
         $xml .= "<description>".EncodeISO($des,$CharSet)."</description>\n";
         }
         $xml .= "</item>";
      } //next

     $xml .= "</channel></rss>";
     echo $xml;
?>