<?php

/* Flatz-Cms */

session_start(); // avvio sessione
$sessione_id = session_id();
error_reporting (E_ALL ^ E_NOTICE); // comando per non stampare gli errori di tipo notice
define("PER", "");
include(PER."cdat.php");
include(PER."lib/funzioni.str"); //inclusione file con le funzioni e costanti principali
if(file_exists(CGEN."config".DTB)) {include(CGEN."config".DTB);}else {echo "<b>Flatz-Cms is not installed!</b>"; die();}

$CMSVersion = "Flatz-Cms 1.0 RC";

if(isset($_GET['mod'])) $_GET['mod'] = Prot($_GET['mod']);
if(isset($_GET['pg']))  $_GET['pg']  = Prot($_GET['pg']);
if(isset($_GET['s']))   $_GET['s']   = Prot($_GET['s']);
if(isset($_GET['lng'])) $_GET['lng'] = Prot($_GET['lng']);

ob_start("ob_gzhandler");

if(isset($_GET['C_S'])) {
setcookie("C_S", "",time()-(7200),"/",""); //cancello cookie skin precedente
setcookie("C_S", stripslashes(strip_tags($_GET['C_S'])),time()+(7200),"/","");  //registro cookie skin valido 1 ora
$REF = preg_replace("/&C_S=[^>]*/si","", $_SERVER['HTTP_REFERER']);
$REF = preg_replace("/&val=[^>]*/si","", $REF);
if(strpos($REF,"index.php?lng=$lng")===false) $REF= $sito[2]."index.php?lng=$lng";
header("location:".$REF);
}
if(isset($LocalTZ) && $LocalTZ!="") date_default_timezone_set($LocalTZ);
else date_default_timezone_set('UTC');
$ip = $_SERVER["REMOTE_ADDR"];  // ip utente
$data = strtotime("now");
$ora = date("H");
$giorno = floor(date("d"));
$mese = date("m");
$anno = date("Y");
$user_agent = $_SERVER["HTTP_USER_AGENT"]; //variabile per rilevare navigatore ed S.O.

//rilevamento navigatore utente

if(!isset($_SESSION['browser'])) {
if(strstr($user_agent, 'Chrome')) $_SESSION['browser'] = 3;
elseif(strstr($user_agent, 'Opera')) $_SESSION['browser'] = 4;
elseif(strstr($user_agent, 'Bot')||strstr($user_agent, 'Google')||strstr($user_agent, 'Slurp')||strstr($user_agent, 'Scooter')||strstr($user_agent, 'Spider')||strstr($user_agent, 'Infoseek')||strstr($user_agent, 'firefly')) $_SESSION['browser'] = 7;
elseif((strstr($user_agent, 'Nav')) || (strstr($user_agent, 'Gold')) || (strstr($user_agent, 'Netscape')) && (!strstr($user_agent, 'MSIE'))) $_SESSION['browser'] = 0;
elseif(strstr($user_agent, 'MSIE')) $_SESSION['browser'] = 1;
elseif(strstr($user_agent, 'Safari')) $_SESSION['browser'] = 5;
elseif(strstr($user_agent, 'Konqueror')) $_SESSION['browser'] = 6;
elseif(strstr($user_agent, 'Firefox')) $_SESSION['browser'] = 8;
elseif(strstr($user_agent, 'Mozilla')) $_SESSION['browser'] = 2;
else $_SESSION['browser'] = 9;
}

//rilevamento S.O. utente

if(!isset($_SESSION['sistema'])) {
if(strstr(strtolower($user_agent), 'linux') || strstr(strtolower($user_agent), 'unix')) $_SESSION['sistema'] = 2;
elseif(strstr($user_agent, 'Win')) $_SESSION['sistema'] = 0;
elseif(strstr($user_agent, 'Mac') || strstr($user_agent, 'PPC')) $_SESSION['sistema'] = 1;
elseif(strstr($user_agent, 'FreeBSD')) $_SESSION['sistema'] = 3;
elseif(strstr($user_agent, 'SunOS')) $_SESSION['sistema'] = 4;
elseif(strstr($user_agent, 'IRIX')) $_SESSION['sistema'] = 5;
elseif(strstr($user_agent, 'BeOS')) $_SESSION['sistema'] = 6;
elseif(strstr($user_agent, 'OS/2')) $_SESSION['sistema'] = 7;
elseif(strstr($user_agent, 'AIX')) $_SESSION['sistema'] = 8;
else $_SESSION['sistema'] = 9;
}

//Connessione automatica (ricorda).

if(empty($_SESSION['login'])&&isset($_COOKIE['remember_cookie'])){
$rm=explode("||",$_COOKIE['remember_cookie']);
if(file_exists(CMBR.strip_tags($rm[0]).DTB)) {
$prefc = lista(CMBR.strip_tags($rm[0]).DTB);
if(isset($prefc[0])&&md5(strip_tags($rm[1]))==md5($prefc[0])) {
$_SESSION['login']=strip_tags($rm[0]);
}
}
}

//recupero dati se utente iscritto

if(isset($_SESSION['login'])) {  // verifica se connesso
$utente = array();
$utente['nome'] = $_SESSION['login'];
if(file_exists(CMBR.$_SESSION['login'].DTB)===false){
unset($_SESSION['login']);
header("location:index.php");
}
$pref = lista(CMBR.$_SESSION['login'].DTB);
$utente['pass'] = $pref[0];
$utente['mail'] = $pref[1];

/* Registrazione connessione su un cookie - per Chat */

setcookie("reg_cookie", "",time()-(3600*18),"/",""); //cancello cookie precedente
setcookie("reg_cookie", $_SESSION['login'],time()+(3600*18),"/","");  //registro cookie chat valido 18 ore

if($_COOKIE['CookieV1']!="M"&&$_SESSION['STAT']!="M") {
$pref[16]++;
$dat=Unisci($pref);
Scrivi(CMBR.$_SESSION['login'].DTB,$dat);
}
}

/* cookie pubblicità */
if(file_exists(CGEN."poppub_C".DTB)) include(CGEN."poppub_C".DTB);
if(($PopPub_4=="2"||$PopPub_4=="4")&&isset($_COOKIE['pub_cookie'])===false)  {
if($PopPub_4=="2") $tmpop = 3;
elseif($PopPub_4=="4") $tmpop = 10;
setcookie("pub_cookie", "",time()-(60*$tmpop),"/",""); //cancello cookie precedente
setcookie("pub_cookie", time(),time()+(60*$tmpop),"/","");  // pub ogni 3 o 10 minuti
$cookpub="ok";
}elseif($PopPub_4=="5"||$PopPub_4=="6") {
if($_COOKIE['pub_cookie_tot']  == $PopPub_9 && isset($_COOKIE['pub_cookie_tot'])){$countpagvis = 1;}
else{$countpagvis = $_COOKIE['pub_cookie_tot'] +1;}
setcookie("pub_cookie_tot", $countpagvis,time()+60,"/","");
$cookpub="ok";
} else $cookpub="";

//rilevamento lingua

if(isset($_GET['lng'])) $lng = $_GET['lng'];

if(empty($lng)) {
  if(!empty($pref[3])){
  $lng = $pref[3];
  } else {
  $lng = $lg[0];
  }
} elseif(in_array($lng,$lg)===false) {
  $lng = $lg[0];
}

for($LNG=0;$LNG<count($lg);$LNG++){
if($lng==$lg[$LNG]) { break; }
}

//inclusione variabili lingua
if(file_exists(CLNG.$lg[$LNG].STR)) {include(CLNG.$lg[$LNG].STR);} elseif($lg[0]!="") {include(CLNG.$lg[0].STR);} else {include(CLNG."en".STR);}

ini_set("default_charset", $CharSet);

if (!isset($_SERVER['REQUEST_URI'])) {
  $RICHIESTA_URL = strip_tags($_SERVER['SCRIPT_NAME']."?".$_SERVER['QUERY_STRING']);
} else { $RICHIESTA_URL = strip_tags($_SERVER['REQUEST_URI']); }

// Login automatico redattori

if(file_exists(CRD)){

 $ListRed = Array();
 $ListRed = lista(CRD);
 $LRED = Array();

  for($i=0;$i<count($ListRed);$i++){
   $LRed = dblin($ListRed[$i]);
   $LRED[] = $LRed[0];

    if(isset($_SESSION['login'])&&$_SESSION['login']==$LRed[0]) {
     $_SESSION['redattore'] = $ListRed[$i];
    }
  }

}

$ListaMembri = ListaFile(CMBR,"d");
$ListaMembri = Alpha_sort($ListaMembri);
$TotaleMembri = count($ListaMembri);

/* Presenze online */

$tsf=0; $DB_F=""; $regdbf = 0;
$ft = @filemtime(CSTA."ora_online".DTB);
$DBF = Array(); $DBF1 = Array(); $DB_IP = Array(); $DB_UT = Array();
$DBF = lista(CSTA."ora_online".DTB);$lutente = "";

for ($s=0; $s<count($DBF); $s++) {
$esp = dblin($DBF[$s]);
if($esp[0]=="vis"||in_array($esp[0],$DB_UT)==false) {
if(!empty($utente['nome'])) {
if($esp[0]==$utente['nome']) {
if(($data-$esp[4])<450){
$DBF1[$s] = $utente['nome'].'<~>'.$ip.'<~>'.$_SESSION['sistema'].'<~>'.$_SESSION['browser'].'<~>'.$data.'<~>'; $regdbf = 1; $DB_UT[] = $utente['nome'];
}
}
elseif (($data-$esp[4])<450) {
$DBF1[$s] = $DBF[$s];
if($esp[0]!="vis") $DB_UT[] = $esp[0];
else $DB_IP[] = $esp[1];
}
} else {
if ($esp[1]==$ip&&$regdbf==0) {
if(($data-$esp[4])<450){
$DBF1[$s] = 'vis<~>'.$ip.'<~>'.$_SESSION['sistema'].'<~>'.$_SESSION['browser'].'<~>'.$data.'<~>'; $regdbf = 1; $DB_IP[] = $esp[1];
}
}
elseif (($data-$esp[4])<450) {
$DBF1[$s] = $DBF[$s];
if($esp[0]!="vis") $DB_UT[] = $esp[0];
else $DB_IP[] = $esp[1];
}
}
}
}
if($regdbf == 0 || count($DBF) == 0) {
if(!empty($utente['nome'])) {
if(in_array($utente['nome'],$DB_UT)==false) $DBF1[] = $utente['nome'].'<~>'.$ip.'<~>'.$_SESSION['sistema'].'<~>'.$_SESSION['browser'].'<~>'.$data.'<~>'; $m=1;
} else {
if(in_array($ip,$DB_IP)==false) $DBF1[] = 'vis<~>'.$ip.'<~>'.$_SESSION['sistema'].'<~>'.$_SESSION['browser'].'<~>'.$data.'<~>'; $v=1;}
}

$DB = Unisci($DBF1);
Scrivi(CSTA."ora_online".DTB,$DB);

/* STATISTICHE */

if($sito[8]=="on") { // misura totale visite se statistiche disattivate

$TOT = lista(CSTA."tot".DTB);
$TOTB = lista(CSTA."totb".DTB);
$totali=Array(); $totalib=Array();
$totali = explode("|",$TOT[0]);
$totalib = explode("|",$TOTB[0]);

if(($regdbf==0||count($DBF)==0)&&isset($_COOKIE['CookieV1'])===false&&isset($_SESSION['STAT'])===false){
  $totali[0]=$totali[0]+1;
  $TCookieV1 = ((24-$ora)*3600)-(floor(date("i"))*60)-57;
  setcookie("CookieV1", "V", time() + $TCookieV1, "/", "");
  $_SESSION['STAT']="V";
}
if(($regdbf==0||count($DBF)==0)&&$_COOKIE['CookieV1']!="M"&&$_SESSION['STAT']!="M"&&$_SESSION['login']){
  $totali[1]=$totali[1]+1;
  $TCookieV2 = ((24-$ora)*3600)-(floor(date("i"))*60)-57;
  setcookie("CookieV1", "M", time() + $TCookieV2, "/", "");
  $_SESSION['STAT']="M";
}
if(strpos($RICHIESTA_URL, "connessione")===false) $totali[2]=$totali[2]+1;

$totv=0+$totali[0];

if($totali[0]<$totalib[0]) $totale=implode("|",$totalib);
else $totale=implode("|",$totali);
if(Scrivi(CSTA."tot".DTB,$totale)) Scrivi(CSTA."totb".DTB,$totale);

} // fine misura totale visite se statistiche disattivate

if($sito[8]!="on") { // Se statistiche abilitate
$s_sg = "";
if(($data-@filemtime(CSTA.$giorno.DTB))>(3600*25)) {
$grn[0]= 0;
$grn[1]= 0;
$grn[2]= 0;
$grn[3]= "|||||||||||||||||||||||||";
$grn[4]= $grn[3];
$s_sg = "ok";
} else {
$grn = lista(CSTA.$giorno.DTB);
$grnb = lista(CSTA."Gbuck".DTB);
if($grn[0]<$grnb[0]) $grn = lista(CSTA."Gbuck".DTB);
}

if(file_exists(CSTA.$anno.DTB)===false) {
for($i=0;$i<12;$i++){
$dbmese[$i] = "||";
}
} else { $dbmese = lista(CSTA.$anno.DTB); }

$tmes = explode("|", $dbmese[date("n")-1]);

$h=explode("|",$grn[3]);
$hm = explode(":", $h[date("G")]);
$bsl=explode("|",$grn[4]);

$TOT = lista(CSTA."tot".DTB);
$TOTB = lista(CSTA."totb".DTB);
$totali=Array(); $totalib=Array();
$totali = explode("|",$TOT[0]);
$totalib = explode("|",$TOTB[0]);

$vis0 = 0 + $grn[0];
$vis1 = 0 + $grn[1];
$vis2 = 0 + $grn[2];

if(($regdbf==0||count($DBF)==0)&&isset($_COOKIE['CookieV1'])===false&&isset($_SESSION['STAT'])===false){
  $totali[0]=$totali[0]+1;
  $grn[0]=$vis0+1;
  $tmes[0]=$tmes[0]+1;
  $hm[0]=$hm[0]+1;
  $bsl[$_SESSION['browser']]++;
  $bsl[10+$_SESSION['sistema']]++;
  $TCookieV1 = ((24-$ora)*3600)-(floor(date("i"))*60)-57;
  setcookie("CookieV1", "V", time() + $TCookieV1, "/", "");
  $_SESSION['STAT']="V";
}
if(($regdbf==0||count($DBF)==0)&&$_COOKIE['CookieV1']!="M"&&$_SESSION['STAT']!="M"&&$_SESSION['login']){
  $totali[1]=$totali[1]+1;
  $grn[2]=$vis2+1;
  $tmes[2]=$tmes[2]+1;
  $hm[2]=$hm[2]+1;
  if($hm[2]>$hm[0]) $hm[2] = $hm[0];
  if($grn[2]>$grn[0]) $grn[2] = $grn[0];
  if($tmes[2]>$tmes[0]) $tmes[2] = $tmes[0];
  $TCookieV2 = ((24-$ora)*3600)-(floor(date("i"))*60)-57;
  setcookie("CookieV1", "M", time() + $TCookieV2, "/", "");
  $_SESSION['STAT']="M";
}

$grn[1]=$vis1;

if(strpos($RICHIESTA_URL, "connessione")===false) {
$totali[2]=$totali[2]+1;
$hm[1]=$hm[1]+1;
$grn[1]=$vis1+1;
$tmes[1]=$tmes[1]+1;
if(count($lg)>1) $bsl[20+$LNG]++;
}
$totv=0+$totali[0];
$totm=0+$totali[1];
$totp=0+$totali[2];

if($totali[0]<$totalib[0]) $totale=implode("|",$totalib);
else $totale=implode("|",$totali);

if(Scrivi(CSTA."tot".DTB,$totale)) Scrivi(CSTA."totb".DTB,$totale);

$dbmese[date("n")-1] = implode("|",$tmes);
Scrivi(CSTA.$anno.DTB,Unisci($dbmese));

$h[date("G")]=implode(":",$hm);
$grn[3]=implode("|",$h);

$grn[4]=implode("|",$bsl);

for($i=5;$i<count($grn);$i++){
$s_m = explode("|",$grn[$i]);
$stat_mod[$s_m[0]] = $s_m[1];
}

if(isset($_GET['mod'])&&isset($stat_mod[$_GET['mod']])) { $stat_mod[$_GET['mod']]=$stat_mod[$_GET['mod']]+1; }

} // Se statistiche abilitate fine

if(!isset($_GET['pg'])) {
$_GET['pg']="home"; //  default=home
$stat_mod['home']=$stat_mod['home']+1;
}

if($sito[8]!="on") { /* Scrittura statistiche se abilitate */
$dbsp = lista(CSTA."config".DTB);
$DBsp = dblin($dbsp[0]);
$grn[5] = "home|".$stat_mod['home'];
for($i=0;$i<count($DBsp);$i++){
if($DBsp[$i]) $grn[6+$i] = $DBsp[$i]."|".$stat_mod[$DBsp[$i]];
}
$DB = Unisci($grn);
if(@filesize(CSTA.$giorno.DTB)>10||$s_sg=="ok") {
if(Scrivi(CSTA.$giorno.DTB,$DB)){  //Scrittura statistiche giornaliere
Scrivi(CSTA."Gbuck".DTB,$DB);
}
}
} // fine scrittura statistiche
$BoxLat="";
if(($_GET['pg']=="admin"||$_GET['pg']=="ccat"||$_GET['pg']=="cestino"|| $_GET['pg']=="editor"||$_GET['pg']=="config") && isset($_SESSION['logadmin'])===true) {
if(empty($skinadm[0]) or strlen($skinadm[0])==1) {$skinadm[0]="Flatz-Complete";}
$skinadmpath = CSTR."skin_a/".$skinadm[0]."/";
}else{$skinadmpath="";}

/* Inclusione della pagina richiesta */
if($man[0]=="on"&&isset($_SESSION['logadmin'])===false) {  // se il sito è in lavorazione
$_GET['pg']="manutenzione";
if(isset($_GET['mod'])) { unset($_GET['mod']); }
} // fine se il sito è in lavorazione

if(isset($_GET['mod'])) {
if((isset($DM[$_GET['mod']])&&$DM[$_GET['mod']]=="on") or (isset($DP[$_GET['mod']])&&$DP[$_GET['mod']]=="on")or !file_exists(CMOD.$_GET['mod'])) { //Pagina disattivata
unset($_GET['mod']); header("location:index.php?lng=$lng&pg=errore");
}
}
$XHead="";
$pagefilter=array('errore','WebMail','editor','editor_red','ricerca','sondaggio','home');
if(isset($_GET['mod'])&&file_exists(CMOD.$_GET['mod']."/".$_GET['pg'].PHP)) {
include(CMOD.$_GET['mod']."/".$_GET['pg'].PHP);
} else {
if($_GET['pg']=="admin"){
if(isset($_GET['s'])&&file_exists(CADM.$_GET['s'].PHP)){
include(CADM.$_GET['s'].PHP);
} else {
include(CADM."admin".PHP);
}
} elseif(in_array($_GET['pg'],$pagefilter)) {
include(LIB.$_GET['pg'].PHP);
}else{
header("location:index.php?lng=$lng&pg=errore");
}
}
?>