<?php
//******************************* Lizenzbestimmungen *******************************//
//                                                                                  //
//  Der Quellcode dieses Forums ist urheberrechtlich geschtzt.                     //
//  Bitte beachten Sie die AGB auf www.frank-karau.de/agb.php                       //
//                                                                                  //
//  Dieser Lizenzhinweis darf nicht entfernt werden.                                //
//                                                                                  //
//  (C) phpFK - Forum ohne MySQL - www.frank-karau.de - support@frank-karau.de      //
//                                                                                  //
//**********************************************************************************//
 
$robots_index = true; 
require './include/page_top.php';

if (IsAdmin() && ($_FORUM['versioncheck']))
{
	if ($_GET['versioncheck'] == 'hide')
	{
		$_FORUM['versioncheck'] = false;
		IniSave('data/forum.ini', $_FORUM);
	}
	else if ($string = @file_get_contents('http://www.frank-karau.de/version.txt'))
	{
		if (version_compare($_FORUM['version'], $string, '<'))
			echo '<div id="notice"><b>Hinweis:</b> Ihr Forum ist nicht mehr aktuell. Die neue Version '.$string.' steht auf <a href="http://www.frank-karau.de" target="_blank">www.frank-karau.de</a> zum Download bereit. [<a href="'.url('index.php?versioncheck=hide').'">'.$_TEXT['HIDE'].'</a>]</div>';
	}
}


//* Content *//
ShowInfotext();
ShowBoards();
ShowStatistic();
ShowLastposts();
//* E N D E *//

function ShowInfotext()
{
	if (file_exists('data/infotext.txt'))
	{
		echo '<div class="content"><table class="main"><tr><td class="w">'.do_ubb(nl2br(file_get_contents('data/infotext.txt'))).'</td></tr></table></div>';
	} 
}

function ShowBoards()
{
	GLOBAL $_BOARDS, $user_in_board, $guests_in_board;
	$arr = array();
	foreach(Group2Array($_BOARDS['index_children']) as $caption)
	{
		$show = false;
		$string = '<table class="main">';
		if ($_BOARDS[$caption] <> '')
		{
			$string .= '<tr><td class="oben" colspan="3"><a name="'.$caption.'"></a><b>'.$_BOARDS[$caption].'</b></td></tr>';
		}
		$class = 'g';
		foreach(Group2Array($_BOARDS[$caption.'_children']) as $item)
		{
			if (substr($item, 0, 1) == 'b')
			{
				$board = substr($item, 1, 100);
				if (is_numeric($board))
				  if (auth('auth_show', false, $board))
				  {
					$string .= PreviewBoard($board, $class, $user_in_board[$board], $guests_in_board[$board]);
					$class = ($class == 'g'?'w':'g');
					$show = true;
				  }
			}

		}
		$string .= '</table>';
		if ($show) $arr[] = $string;
	}
	echo '<div class="content">'.implode('<img src="images/blank.gif" style="height:5px;border:0px">', $arr).'</div>';
}


function ShowStatistic()
{
  GLOBAL $_BOARDS, $_TEXT, $_FORUM, $_COUNT, $count_online_user;
  if (auth_guestuser('settings_design_showstat')) 
  {
	$threads_count = 0;
	$answeres_count = 0;

	foreach(Group2Array($_BOARDS['order']) as $item)
	{
		if (substr($item, 0, 1) == 'b')
		{
			$ini = IniLoad('data/'.substr($item, 1, 100).'/board.ini');
			$threads_count += $ini['topics'];
			$answeres_count += $ini['answeres'];
		}
	}

 	echo '
	<div class="content">
		<table class="main"> 
			<tr><td class="oben" colspan="2"><b><a name="stat"></a>'.$_TEXT['STAT'].'</b></td></tr>
			<tr><td class="g" colspan="2">
				<b>'.$_COUNT['online'].' '.($_COUNT['online']==1?$_TEXT['STAT_X_ONLINE']:$_TEXT['STAT_XX_ONLINE']).' 
					('.count($count_online_user).' '.(count($count_online_user) == 1?$_TEXT['STAT_USER']:$_TEXT['STAT_USERS']).' 
					'.$_TEXT['STAT_AND'].' 
					'.($_COUNT['online']-count($count_online_user)).' '.(($_COUNT['online']-count($count_online_user)) == 1?$_TEXT['STAT_GUEST']:$_TEXT['STAT_GUESTS']).')
				</b>
				'.(auth_guestuser('settings_design_showwhois', true)?' | <a href="'.url('whoisonline.php').'">'.$_TEXT['NAV_WHOISONLINE'].'</a>':'').'
			</td></tr>
 			<tr>
				<td class="w" style="text-align:center;width:5%;"><img src="./styles/'.$_FORUM['settings_design_style'].'/images/usersM.png" alt=""></td>
				<td class="w" style="width:95%;">
	';
 				foreach($count_online_user as $user) {if ($user != $count_online_user[0]) {echo ', ';} echo user($user);}
 	echo '
				<p class="sub">'.$_TEXT['STAT_TODAY'].': '.fnum($_COUNT['today']).'
	';
				if (count(Group2Array($_COUNT['today_user']))>0)
				{
					echo ' (';
					$items = Group2Array($_COUNT['today_user']);
					foreach($items as $item) 
					{
						if ($item <> $items[0]) echo ', ';
						echo user($item);
					}
					echo ')';
				}
	echo '
 				| '.$_TEXT['STAT_TOTAL'].': '.fnum($_COUNT['entire']).'</p>
				</td>
			</tr>
			<tr>
				<td class="g" style="text-align:center;"><img src="styles/'.$_FORUM['settings_design_style'].'/images/statM.png" alt=""></td>
				<td class="g">'.$_TEXT['TOPICS'].': '.fnum($threads_count).' | '.$_TEXT['ANSWERES'].': '.fnum($answeres_count).' | '.$_TEXT['STAT_USER'].': '.fnum(count(LoadFileList('./data/user/', '.usr.ini'))).'
	';
 			if (IsUser($_FORUM['newest_user'])) echo ' | '.$_TEXT['STAT_NEWEST_USER'].': '.user($_FORUM['newest_user']);
 	echo '
				</td>
			</tr>
		</table>
	</div>
	';
  }
}


function ShowLastposts()
{
  GLOBAL $_BOARDS, $_TEXT, $_FORUM, $TRENNZEICHEN;
  if (auth_guestuser('settings_design_showlast')) 
  {
 	echo '
		<div class="content">
			<table class="main">
 				<tr><td class="oben" colspan="3">
	';
 				if ($_FORUM['settings_design_rss'])
 				{
 					echo ' <a href="'.url('rss.php').'" target="_blank"><img src="images/rss.gif" alt="XML | RSS 2.0 Feed" title="XML | RSS 2.0 Feed" align="right"></a>';
 				}
 	echo '
				'.MultiReplace($_TEXT['STAT_LAST_POSTS'], $_FORUM['settings_design_lastposts_count']).'</td></tr>
	';
	$hist = FileLoad('data/history.txt');
	$i_begin = count($hist)-$_FORUM['settings_design_lastposts_count'];
	$i_end = count($hist)-1;
	if ($i_begin < 0) $i_begin = 0;
	if ($i_end < 0) $i_end = 0;
	$class = 'g';
	for ($i=$i_end; $i >= $i_begin; $i--)
	{
		if (auth('auth_show', false, $hist[$i][0]))
		{ 
			$post_filename = 'data/'.$hist[$i][0].'/'.$hist[$i][1].'.txt';
			if (file_exists($post_filename))
			{ 
				$post = file($post_filename);
 				if (count($post) > $hist[$i][2])
 				{ 
					$post_link = url('thread.php',$hist[$i][0],$hist[$i][1],$hist[$i][2]);
    					$post_array = explode($TRENNZEICHEN, $post[$hist[$i][2]]);
 					$post_text = history_text($post_array[2], $post_array[3], 70);
 					$post_date = $post_array[0];
 					$post_from = $post_array[1];
					$post_att = (strlen($post_array[5])>8);
					$post_poll = (file_exists('data/poll_'.$post_array[6].'.ini'));
 					echo '
						<tr>
							<td class="'.$class.'" style="padding:4px;width:70%;"><img src="styles/'.$_FORUM['settings_design_style'].'/images/threadS.png" alt="" style="vertical-align:middle;"></a> <a href="'.$post_link.'">'.$post_text.'</a></td>
							<td class="'.$class.'" style="padding:4px;width:5%;text-align:right;">
								'.($post_att?'<img src="styles/'.$_FORUM['settings_design_style'].'/images/downloadS.png" border="0" alt="'.$_TEXT['UPLOAD_ATT'].'" />&nbsp;':'').'
								'.($post_poll?'<img src="styles/'.$_FORUM['settings_design_style'].'/images/pollS.png" border="0" alt="'.$_TEXT['POLL'].'" />&nbsp;':'').'
							</td>
							<td class="'.$class.'" style="padding:4px;width:25%;"><p class="sub">'.ftime($post_date).' '.$_TEXT['BY'].' '.user($post_from).'</p></td>
						</tr>
					';
					$class = ($class=='g'?'w':'g');
 				}
			} 
		} 
		else 
		{
			if ($i_begin > 0) $i_begin--;
		}
	}
 	echo '
				</td></tr>
			</table>
		</div>
	'; 
  }
}  

require './include/page_bottom.php';  
?>