<?php
//******************************* Lizenzbestimmungen *******************************//
//                                                                                  //
//  Der Quellcode dieses Forums ist urheberrechtlich geschtzt.                     //
//  Bitte beachten Sie die AGB auf www.frank-karau.de/agb.php                       //
//                                                                                  //
//  Dieser Lizenzhinweis darf nicht entfernt werden.                                //
//                                                                                  //
//  (C) phpFK - Forum ohne MySQL - www.frank-karau.de - support@frank-karau.de      //
//                                                                                  //
//**********************************************************************************//

$LOADING_TIME_START = strtok(microtime(), ' ') + strtok('');
if (!in_array(basename($_SERVER['PHP_SELF']), array('download.php'))) ob_start("ob_gzhandler");
if ($_GET['debug'] <> '') define('DEBUG', 1);
@include 'config.ini.php';
if (!defined('CONFIG_POST_MAXCHAR')) DEFINE('CONFIG_POST_MAXCHAR', 5000);
define('DIR', '');
require_once './include/functions.php';
if (!defined('DEBUG'))
{
	error_reporting(E_ERROR);
	ini_set('error_reporting', 'E_ERROR');
}
ini_set('url_rewriter.tags','');
ini_set('register_globals', '0');
header('Cache-control: private');
session_name('sid');
session_start();

// Standard-Variablen setzen
$_FORUM = array();
while ((count($_FORUM) < 10) && ($counter < 5))
{
	$_FORUM = IniLoad('data/forum.ini');
	$counter++;
}
if (count($_FORUM) < 10)
{
	$_FORUM = IniLoad('data/forum.tmp.ini');
	if (count($_FORUM) > 10) IniSave('data/forum.ini', $_FORUM);
}
$_BOARDS = IniLoad('data/boards.ini');
$_ADMINS = IniLoad('data/user/Admins.grp.ini');
$history_filename = 'data/history.txt';
$_SUBNAV = array();
$_SUBNAV_RIGHT = '';
$_SUBNAV_BOTTOM = '';

@include('update.php');

if (!file_Exists('./styles/'.$_FORUM['settings_design_style'].'/text.css')) $_FORUM['settings_design_style'] = 'default';
require_once 'languages/de.php';
if (file_Exists('./languages/'.$_FORUM['settings_forum_language']) AND ($_FORUM['settings_forum_language'] != '')) require_once './languages/'.$_FORUM['settings_forum_language'];

$check_new_posts = false;
if ($_SESSION['IP'] == '') $_SESSION['IP'] = $_SERVER['REMOTE_ADDR'];
if ((($_GET['action'] == 'logout') OR ($_GET['action'] == 'delete2')) && !($_POST['action']=='login'))
{
	if ($_COOKIE['loginname'] != '')
	{
	 	setcookie("loginpasswd", "n/a", time()+100, '/');
		$_COOKIE['loginname'] = '';
		$_COOKIE['loginpasswd'] = '';
	}
	$_SESSION['Benutzername'] = '';
	session_destroy();
}
else if (($_GET['action'] == 'login') OR ($_POST['action'] == 'login'))
{
	$login_timeout = false;
	if (file_exists('./data/user/'.$_POST['name'].'.usr.log'))
	{
		$ini = IniLoad('./data/user/'.$_POST['name'].'.usr.log');
		if ($ini['timeout'] != '')
		{
			if ($ini['timeout'] > time())
			{
				$login_timeout = true;
			}
			else
			{
				@unlink('./data/user/'.$_POST['name'].'.usr.log');
			}
		}
	}
	if ($login_timeout)
	{
		$MSG_ERROR = $_TEXT['ERROR_LOGIN_TIMEOUT'];
	}
	else
	{
		if (file_exists('./data/user/'.$_POST['name'].'.usr.tmp'))
		{
			$ini = IniLoad('./data/user/'.$_POST['name'].'.usr.tmp');
			if (md5($_POST['passwd']) == $ini['password'])
			{
				if (rename('./data/user/'.$_POST['name'].'.usr.tmp', './data/user/'.$_POST['name'].'.usr.ini'))
				{
					$_FORUM['newest_user'] = $_POST['name'];
					IniSave('./data/forum.ini', $_FORUM);
					if ($_FORUM['settings_admin_notification'])
					{
						SendMessage(Group2Array($_ADMINS['members']), '', $_POST['name'].' '.$_TEXT['MSG_NEW_USER']);
					}
				}
			}
		}
		if (val_user($_POST['name'], $_POST['passwd']))
		{
			$_SESSION['Benutzername'] = $_POST['name'];
			if ($_POST['cookie'] == "on")
			{
		  		setcookie("loginpasswd", md5($_POST['passwd']), time()+99999999999999, '/');
			}
			setcookie("loginname", $_POST['name'], time()+99999999999999, '/');
			$check_new_posts = true;
			@unlink('./data/user/'.$_POST['name'].'.usr.log');
			PluginHook('login', $_SESSION['Benutzername'], $_SESSION['IP']);
		}
		else
		{
			if (file_exists('data/user/'.$_POST['name'].'.usr.ini'))
			{
				$ini = IniLoad('data/user/'.$_POST['name'].'.usr.log');
				$ini['wrong_login']++;
				if ($ini['wrong_login'] > 3)
				{
					$ini['timeout'] = time()+600;
					$MSG_ERROR = $_TEXT['ERROR_LOGIN_TIMEOUT'];
				}
				IniSave('data/user/'.$_POST['name'].'.usr.log', $ini);
			}
			if ($MSG_ERROR == '') $MSG_ERROR = $_TEXT['ERROR_WRONG_LOGIN'];
		}
	}
}
else
{
	if ((!$_SESSION['Benutzername']) && (val_user_md5($_COOKIE['loginname'], $_COOKIE['loginpasswd'])) && ($_GET['action'] != 'logout'))
	{
		$_SESSION['Benutzername'] = $_COOKIE['loginname'];
		$check_new_posts = true;
		PluginHook('login_cookie', $_SESSION['Benutzername'], $_SESSION['IP']);
	}
	if (!IsUser()) $_SESSION['Benutzername'] = '';
}

// * New Posts * //
if (($check_new_posts) && (file_exists("./data/user/".$_SESSION['Benutzername'].".usr.ini")))
{
	$udat = IniLoad("./data/user/".$_SESSION['Benutzername'].".usr.ini");
	if ($udat['lastonline_date'] <> '')
	{
		$_SESSION['new_posts_date'] = $udat['lastonline_date'];
		$_SESSION['new_posts_seen'] = '';
		$_SESSION['new_posts_boards_seen'] = '';
     	}

}

if (IsUser())
{
	$udat = IniLoad('./data/user/'.$_SESSION['Benutzername'].'.usr.ini');
	if ((count($udat) > 0) AND
	   (
		(($udat['lastonline_date']+100) < time())
	     OR
		(basename($_SERVER['PHP_SELF']) == 'do.php')
	   ))
	{
		$udat['lastonline_date'] = time();
		IniSave('./data/user/'.$_SESSION['Benutzername'].'.usr.ini', $udat);
	}
}

// * Stat * //
$_COUNT = IniLoad('./data/count.ini');
if (($_COUNT['entire'] == '') && file_exists('./data/count.tmp.ini'))
{
	$_COUNT = IniLoad('./data/count.tmp.ini');
}
if ($_COUNT['day'] != date("d.m.y", time()))
{
	$_COUNT['day'] = date("d.m.y", time());
	$_COUNT['today'] = '';
	$_COUNT['today_user'] = '';
	IniSave('./data/count.ini', $_COUNT);
	IniSave('./data/count.tmp.ini', $_COUNT);
	@unlink('./data/count_online.txt');
	@unlink('./data/count_bots.ini');
}
$count_online_user = array();
for ($i=0; $i<1000; $i++)
{
	$user_in_board[$i] = array();
	$user_in_thema[$i] = array();
	$guests_in_board[$i] = 0;
	$guests_in_thema[$i] = 0;
}
function count_bot($bot)
{
	GLOBAL $_GET;
	$_COUNT_BOTS = IniLoad('./data/count_bots.ini');
	$_COUNT_BOTS[$bot.'_count']++;
	$_COUNT_BOTS[$bot.'_lastonline'] =  time();
	$_COUNT_BOTS[$bot.'_board'] = $_GET['board'];
	$_COUNT_BOTS[$bot.'_thema'] == $_GET['thema'];
	IniSave('./data/count_bots.ini', $_COUNT_BOTS);
}
if (eregi('gigablast', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('gigablast');
}
else if (eregi('googlebot', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('google');
}
else if (eregi('yahoo! slurp', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('yahoo');
}
else if (eregi('msnbot', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('msn');
}
else if (eregi('seekbot', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('seekbot');
}
else if (eregi('twiceler', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('twiceler');
}
else if (eregi('cazoodle', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('cazoodle');
}
else if (eregi('webalta crawler', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('webalta');
}
else if (eregi('speedy spider', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('speedyspider');
}
else if (eregi('libwww-perl', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('libwww-perl');
}
else if (eregi('msiecrawler', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('msiecrawler');
}
else if (eregi('Mediapartners-Google', $_SERVER['HTTP_USER_AGENT']))
{
	count_bot('Mediapartners-Google');
}
else if ((eregi('robot', $_SERVER['HTTP_USER_AGENT'])) OR
	 (eregi('feedfetcher', $_SERVER['HTTP_USER_AGENT'])) OR
	 (eregi('crawl', $_SERVER['HTTP_USER_AGENT'])) OR
	 (eregi('spider', $_SERVER['HTTP_USER_AGENT'])) OR
	 (eregi('bot-', $_SERVER['HTTP_USER_AGENT'])) OR
	 (eregi('bot/', $_SERVER['HTTP_USER_AGENT'])))
{
	count_bot('unknown');
}
else
{
	$count_data = FileLoad('./data/count_online.txt');
	$hidestatus = false;
	if (IsUser())
	{
		$ini = IniLoad('data/user/'.$_SESSION['Benutzername'].'.usr.ini');
		$hidestatus = ($ini['settings_hidestatus'] && ($_FORUM['settings_user_hidestatus'] OR IsAdmin()));
	}

	$count_gefunden = false;
	for ($i=0; $i<count($count_data); $i++)
	{
		if ($count_data[$i][0] < (time() - 300))
		{
			$count_data[$i][0] = '-';
		}
		else
		{
			if (IsUser() && ($count_data[$i][6] == $_SESSION['Benutzername']))
			{
				$count_data[$i][0] = time();
				if ($count_gefunden) $count_data[$i][0] = "-";
				$count_data[$i][1] = $_SESSION['IP'];
				$count_data[$i][2] = ($hidestatus ? '' : $_SESSION['Benutzername']);
				$count_data[$i][3] = $_GET['board'];
				$count_data[$i][4] = $_GET['thema'];
				$count_data[$i][5] = getBrowser($_SERVER['HTTP_USER_AGENT']);
				$count_gefunden = true;
			}
			else if ($count_data[$i][1] == $_SESSION['IP'])
			{
				$count_data[$i][0] = time();
				if ($count_gefunden) $count_data[$i][0] = "-";
				$count_data[$i][2] = ($hidestatus ? '' : $_SESSION['Benutzername']);
				$count_data[$i][3] = $_GET['board'];
				$count_data[$i][4] = $_GET['thema'];
				$count_data[$i][5] = getBrowser($_SERVER['HTTP_USER_AGENT']);
				$count_data[$i][6] = $_SESSION['Benutzername'];
				$count_gefunden = true;
			}
			if ($count_data[$i][2] != '')
			{
				array_push($count_online_user, $count_data[$i][2]);
				if (!IsInGroup($_COUNT['today_user'], $count_data[$i][2]))
				{
					AddToGroup($_COUNT['today_user'], $count_data[$i][2]);
					IniSave('./data/count.ini', $_COUNT);
					IniSave('./data/count.tmp.ini', $_COUNT);
				}
			}
			if (is_numeric($count_data[$i][3]))
			{
				if ($count_data[$i][2] != '')
				{
					@array_push($user_in_board[$count_data[$i][3]], $count_data[$i][2]);
				}
				else
				{
					$guests_in_board[$count_data[$i][3]]++;
				}
				if ($count_data[$i][3] == $_GET['board'])
				{
					if ($count_data[$i][2] != '')
					{
						@array_push($user_in_thema[$count_data[$i][5]], $count_data[$i][2]);
					}
					else
					{
						$guests_in_thema[$count_data[$i][5]]++;
					}
				}
			}
		}
	}

	if (!$count_gefunden)
	{
		array_push($count_data, array(time(), $_SESSION['IP'], ($hidestatus ? '' : $_SESSION['Benutzername']), $_GET['board'], $_GET['thema'], getBrowser($_SERVER['HTTP_USER_AGENT']), $_SESSION['Benutzername']));
		if (($_SESSION['Benutzername'] <> '') && (!$hidestatus))
		{
			array_push($count_online_user, $_SESSION['Benutzername']);
			AddToGroup($_COUNT['today_user'], $_SESSION['Benutzername']);
		}
		$_COUNT['entire']++;
		$_COUNT['today']++;
		IniSave('./data/count.ini', $_COUNT);
	}
	FileSave('./data/count_online.txt', $count_data);
}
$count_data = FileLoad('./data/count_online.txt');
$_COUNT['online'] = count($count_data);

// * System: Lastcheck * //
if (($_FORUM['system_lastcheck']+86400 < time()) OR ($_GET['system_lastcheck']=='true'))
{
	$_FORUM['system_lastcheck'] = time();

	IniSave('./data/forum.ini', $_FORUM);
	if (count($_FORUM) > 10) IniSave('./data/forum.tmp.ini', $_FORUM);

	$tmpusers = LoadFileList('./data/user/', '.usr.tmp');
	foreach ($tmpusers as $user)
	{
		$ini = IniLoad('./data/user/'.$user);
		if ($ini['register_date']+864000 < time()) unlink('./data/user/'.$user);
	}
}

?>