<?php
//******************************* Lizenzbestimmungen *******************************//
//                                                                                  //
//  Der Quellcode dieses Forums ist urheberrechtlich geschtzt.                     //
//  Bitte beachten Sie die AGB auf www.frank-karau.de/agb.php                       //
//                                                                                  //
//  Dieser Lizenzhinweis darf nicht entfernt werden.                                //
//                                                                                  //
//  (C) phpFK - Forum ohne MySQL - www.frank-karau.de - support@frank-karau.de      //
//                                                                                  //
//**********************************************************************************//

require './include/init.php';

if (!auth_guestuser('settings_design_showstat', true)) 
{
	require './index.php';
	Exit;
}

$_SUBNAV[] = array($_TEXT['NAV_WHOISONLINE'], url('whoisonline.php'));

require './include/page_top.php';

echo '
	<div id="content">
		<table class="main">
			<tr><td colspan="3" class="oben">'.$_TEXT['NAV_WHOISONLINE'].'</td></tr>
';

$class = 'class="g"';

function selfsort($a, $b) {
   return ($a[0] < $b[0]) ? 1 : -1;
}

usort($count_data, 'selfsort');

foreach ($count_data as $item)
{
	echo '
			<tr>
				<td '.$class.' width="140" style="width:140px;">'.($item[2]<>''?user($item[2]):$_TEXT['STAT_GUEST']).'<p class="sub">'.(IsAdmin()&&$item[1]<>''?$item[1].'<br />':'').$item[5].'</p></td>
				<td '.$class.' width="100" style="width:100px;">'.ftime($item[0]).'</td>
				<td '.$class.' width="*" style="width:auto;">
	';
				if (is_numeric($item[3]) && file_exists('./data/'.$item[3].'/board.ini'))
				{
					$ini = IniLoad('./data/'.$item[3].'/board.ini');
					echo '<a href="'.url('board.php', $item[3]).'">'.$ini['title'].'</a>';
					if (is_numeric($item[4]) && file_exists('./data/'.$item[3].'/'.$item[4].'.txt.ini'))
					{
						$ini = IniLoad('./data/'.$item[3].'/'.$item[4].'.txt.ini');
						echo ' &raquo; <a href="'.url('thread.php', $item[3], $item[4]).'">'.($ini['title']<>''?$ini['title']:'...').'</a>';
					}
				}
	echo '
				</td>
			</tr>
	';
	$class = ($class=='class="w"'?'class="g"':'class="w"');
}

echo '
		</table>
	</div>
';

echo '
	<div id="content">
		<table class="main">
			<tr><td colspan="3" class="oben">'.$_TEXT['STAT_BOTS'].'</td></tr>
';

$_COUNT_BOTS = IniLoad('./data/count_bots.ini');
$class = 'class="g"';

function bot($item, $name)
{
	GLOBAL $_COUNT_BOTS, $class;
	if ($_COUNT_BOTS[$item.'_count'] <> '')
	{
		echo '
			<tr>
				<td '.$class.' style="width:140px;">'.$name.' ('.$_COUNT_BOTS[$item.'_count'].'x)</td>
				<td '.$class.' style="width:100px;">'.ftime($_COUNT_BOTS[$item.'_lastonline']).'</td>
				<td '.$class.' style="width:auto;">
	';
				if (is_numeric($_COUNT_BOTS[$item.'_board']) && (file_exists('./data/'.$_COUNT_BOTS[$item.'_board'].'/board.ini')))
				{
					$ini = IniLoad('./data/'.$_COUNT_BOTS[$item.'_board'].'/board.ini');
					echo '<a href="'.url('board.php', $_COUNT_BOTS[$item.'_board']).'">'.$ini['title'].'</a>';
					if (is_numeric($_COUNT_BOTS[$item.'_thema']) && (file_exists('./data/'.$_COUNT_BOTS[$item.'_board'].'/'.$_COUNT_BOTS[$item.'_thema'].'.txt.ini')))
					{
						$ini = IniLoad('./data/'.$_COUNT_BOTS[$item.'_board'].'/'.$_COUNT_BOTS[$item.'_thema'].'.txt.ini');
						echo ' &raquo; <a href="'.url('thread.php', $_COUNT_BOTS[$item.'_board'], $_COUNT_BOTS[$item.'_thema']).'">'.($ini['title']<>''?$ini['title']:'...').'</a>';
					}
				}
	echo '
				</td>
			</tr>
		';
		$class = ($class=='class="w"'?'class="g"':'class="w"');
	}
}

bot('cazoodle', '<a href="http://www.cazoodle.com/cazoodlebot" target="_blank">CazoodleBot Crawler</a>');
bot('gigablast', '<a href="http://www.gigablast.com/spider.html" target="_blank">Gigabot</a>');
bot('google', '<a href="http://www.google.com/bot.html" target="_blank">Googlebot</a>');
bot('Mediapartners-Google', '<a href="http://www.google.com/adsense/" target="_blank">Google AdSense</a>');
bot('libwww-perl', 'libwww-perl');
bot('msiecrawler', 'MSIECrawler');
bot('msn', '<a href="http://search.msn.com/msnbot.htm" target="_blank">MSNBot</a>');
bot('seekbot', '<a href="http://www.seekbot.net/bot.html" target="_blank">Seekbot</a>');
bot('speedyspider', '<a href="http://www.entireweb.com/about/search_tech/speedy_spider/" target="_blank">Speedy Spider</a>');
bot('twiceler', '<a href="http://www.cuill.com/twiceler/robot.html" target="_blank">Twiceler</a>');
bot('webalta', '<a href="http://www.webalta.net/ru/about_webmaster.html" target="_blank">WebAlta</a>');
bot('yahoo', '<a href="http://help.yahoo.com/help/us/ysearch/slurp" target="_blank">Yahoo! Slurp</a>');
bot('unknown', $_TEXT['STAT_BOTS_UNKNOWN']);

echo '
		</table>
	</div>
';


require './include/page_bottom.php';
?>