<?php

require_once('lib/html2pdf/html2pdf.class.php');

function DecodeISO($textin) {

$textout = strip_tags(html_entity_decode($textin));
$textout = str_replace("&nbsp;"," ",$textout);
$textout = str_replace("&deg;","°",$textout);
$textout = str_replace("&sect;","§",$textout);
$textout = str_replace("&pound;","£",$textout);
$textout = str_replace("&quot;","\"",$textout);
$textout = str_replace("&amp;","&",$textout);
$textout = str_replace("&lt;","<",$textout);
$textout = str_replace("&gt;",">",$textout);
$textout = str_replace("&OElig;","",$textout);
$textout = str_replace("&oelig;","",$textout);
$textout = str_replace("&Scaron;","",$textout);
$textout = str_replace("&scaron;","",$textout);
$textout = str_replace("&circ;","",$textout);
$textout = str_replace("&tilde;","",$textout);
$textout = str_replace("&ensp;"," ",$textout);
$textout = str_replace("&emsp;","",$textout);
$textout = str_replace("&ndash;","",$textout);
$textout = str_replace("&mdash;","",$textout);
$textout = str_replace("&lsquo;","",$textout);
$textout = str_replace("&rsquo;","",$textout);
$textout = str_replace("&ldquo;","",$textout);
$textout = str_replace("&rdquo;","",$textout);
$textout = str_replace("&dagger;","",$textout);
$textout = str_replace("&Dagger;","",$textout);
$textout = str_replace("&permil;","",$textout);
$textout = str_replace("&lsaquo;","",$textout);
$textout = str_replace("&rsaquo;","",$textout);
$textout = str_replace("&euro;","",$textout);
$textout = str_replace("&Agrave;","À",$textout);
$textout = str_replace("&Aacute;","Á",$textout);
$textout = str_replace("&Acirc;","Â",$textout);
$textout = str_replace("&Atilde;","Ã",$textout);
$textout = str_replace("&Auml;","Ä",$textout);
$textout = str_replace("&Aring;","Å",$textout);
$textout = str_replace("&AElig;","Æ",$textout);
$textout = str_replace("&Ccedil;","Ç",$textout);
$textout = str_replace("&Egrave;","È",$textout);
$textout = str_replace("&Eacute;","É",$textout);
$textout = str_replace("&Ecirc;","Ê",$textout);
$textout = str_replace("&Euml;","Ë",$textout);
$textout = str_replace("&Igrave;","Ì",$textout);
$textout = str_replace("&Iacute;","Í",$textout);
$textout = str_replace("&Icirc;","Î",$textout);
$textout = str_replace("&Iuml;","Ï",$textout);
$textout = str_replace("&Ntilde;","Ñ",$textout);
$textout = str_replace("&Ograve;","Ò",$textout);
$textout = str_replace("&Oacute;","Ó",$textout);
$textout = str_replace("&Ocirc;","Ô",$textout);
$textout = str_replace("&Otilde;","Õ",$textout);
$textout = str_replace("&Ouml;","Ö",$textout);
$textout = str_replace("&Oslash;","Ø",$textout);
$textout = str_replace("&Ugrave;","Ù",$textout);
$textout = str_replace("&Uacute;","Ú",$textout);
$textout = str_replace("&Ucirc;","Û",$textout);
$textout = str_replace("&Uuml;","Ü",$textout);
$textout = str_replace("&szlig;","ß",$textout);
$textout = str_replace("&agrave;","à",$textout);
$textout = str_replace("&aacute;","á",$textout);
$textout = str_replace("&acirc;","â",$textout);
$textout = str_replace("&atilde;","ã",$textout);
$textout = str_replace("&auml;","ä",$textout);
$textout = str_replace("&aring;","å",$textout);
$textout = str_replace("&aelig;","æ",$textout);
$textout = str_replace("&ccedil;","ç",$textout);
$textout = str_replace("&egrave;","è",$textout);
$textout = str_replace("&eacute;","é",$textout);
$textout = str_replace("&ecirc;","ê",$textout);
$textout = str_replace("&euml;","ë",$textout);
$textout = str_replace("&igrave;","ì",$textout);
$textout = str_replace("&iacute;","í",$textout);
$textout = str_replace("&icirc;","î",$textout);
$textout = str_replace("&iuml;","ï",$textout);
$textout = str_replace("&ntilde;","ñ",$textout);
$textout = str_replace("&ograve;","ò",$textout);
$textout = str_replace("&oacute;","ó",$textout);
$textout = str_replace("&ocirc;","ô",$textout);
$textout = str_replace("&oelig;","",$textout);
$textout = str_replace("&otilde;","õ",$textout);
$textout = str_replace("&ouml;","ö",$textout);
$textout = str_replace("&oslash;","ø",$textout);
$textout = str_replace("&ugrave;","ù",$textout);
$textout = str_replace("&uacute;","ú",$textout);
$textout = str_replace("&ucirc;","û",$textout);
$textout = str_replace("&uuml;","ü",$textout);
$textout = str_replace("&yuml;","ÿ",$textout);

return $textout;
}

$risp = ""; $whp = 0;

define("PER","");
include("cdat.php");
include("lib/funzioni.str");
include(CGEN."config".DTB);

$mod = Prot($_GET['mod']);
$doc = Prot($_GET['doc']);
$lng = Prot($_GET['lng']);
$cat = Prot($_GET['c']);
if(isset($_GET['mid'])) $mid = Prot($_GET['mid']);

include(CLNG.$lng.STR);
ini_set("default_charset", $CharSet);
for($LNG=0;$LNG<count($lg);$LNG++){
if($lng==$lg[$LNG]) { break; }
}

if($mod=="notizie") {
$DB = Lista(CNOT.$cat."/".$doc.DTB);
$nws = dblin($DB[$LNG]);
if($nws[1]==""||$nws[3]=="") $nws = dblin($DB[0]);
$listcat = lista(CNOT."cat".DTB);
for($i=0;$i<count($listcat);$i++){
$dbcat=dblin($listcat[$i]);
$DBCat = explode("||",$dbcat[0]);
if($dbcat[1]==$nws[0]) {
if(isset($DBCat['LNG'])) $NomeCat = $DBCat['LNG'];
else $NomeCat = $DBCat['0'];
break;
}
}
}
elseif($mod=="blog") {
$DBnews=lista(CBLG.$doc.DTB);
$nws = dblin($DBnews[$LNG]);
if($nws[5]==""||$nws[6]=="") $nws = dblin($DBnews[0]);
$listcat = lista(CBLG."cat".DTB);
for($i=0;$i<count($listcat);$i++){
$dbcat=dblin($listcat[$i]);
$DBCat = explode("||",$dbcat[0]);
if($dbcat[1]==$nws[0]) {
if($dbcat[$LNG]!="") { $NomeCat = $DBCat[$LNG]; } else { $NomeCat = $DBCat['0']; }
break;
}
}
}
elseif($mod=="articoli") {
$DB = Lista(CART.$cat."/".$doc.DTB);
$nws = dblin($DB[$LNG]);
if($nws[1]==""||$nws[3]=="") $nws = dblin($DB[0]);
$listcat = lista(CART."cat".DTB);
for($i=0;$i<count($listcat);$i++){
$dbcat=dblin($listcat[$i]);
$DBCat = explode("||",$dbcat[0]);
if($dbcat[1]==$nws[0]) {
if(isset($DBCat['LNG'])) $NomeCat = $DBCat['LNG'];
else $NomeCat = $DBCat['0'];
break;
}
}
}
elseif($mod=="faq") {
$DB = Lista(CFAQ.$cat."/".$doc.DTB);
$nws = dblin($DB[$LNG]);
if($nws[1]==""||$nws[3]=="") $nws = dblin($DB[0]);
$listcat = lista(CFAQ."cat".DTB);
for($i=0;$i<count($listcat);$i++){
$dbcat=dblin($listcat[$i]);
$DBCat = explode("||",$dbcat[0]);
if($dbcat[1]==$nws[0]) {
if(isset($DBCat['LNG'])) $NomeCat = $DBCat['LNG'];
else $NomeCat = $DBCat['0'];
break;
}
}
}

if($mod=="notizie"||$mod=="articoli"||$mod=="faq") {
if($NomeCat!="") $oggetto = DecodeISO($NomeCat." - ".$nws[1]);
else $oggetto = DecodeISO($nws[1]);
$testo = str_replace("[~n~]","\n",$nws[3]);
if($mod=="articoli") {
$dati= DecodeISO($txt[22]." : ".$nws[2]."  @  ".Fdata($nws[5]));
}
elseif($mod=="notizie"){
$dati= DecodeISO($txt[22]." : ".$nws[2]."  @  ".Fdata($doc));
}
} // fine notizie & articoli
elseif($mod=="blog") {
if($NomeCat!="") $oggetto = DecodeISO($NomeCat." - ".$nws[5]);
else $oggetto = DecodeISO($nws[5]);
$testo = str_replace("[~n~]","\n",$nws[6]);
$dati= DecodeISO($txt[22]." : ".$nws[1]."  @  ".Fdata($_GET['doc']));
}

$testo = str_replace('href=\'uploads/','href=\''.$sito[2].'uploads/',$testo);
$testo = str_replace('href="uploads/','href="'.$sito[2].'uploads/',$testo);
$testo = str_replace('href=uploads','href='.$sito[2].'uploads',$testo);

$testo = str_replace('href=\'index.php','href=\''.$sito[2].'index.php',$testo);
$testo = str_replace('href="index.php','href="'.$sito[2].'index.php',$testo);
$testo = str_replace('href=index.php','href='.$sito[2].'index.php',$testo);

$testo = str_replace('href=\'?','href=\''.$sito[2].'?',$testo);
$testo = str_replace('href="?','href="'.$sito[2].'?',$testo);
$testo = str_replace('href=?','href='.$sito[2].'?',$testo);

$sopra = "<div style='border:solid 1px #000066;background-color:#C1CAFF;padding:5px;'>".$oggetto."</div><br>";
$sotto = "<br><hr>".$dati." | <a href='".$sito[2]."'>".$sito[2]."</a><br>";
if($mod=="articoli"&&file_exists($nws[8])) {
$testo= '<img src="'.$nws[8].'" alt="'.$nws[1].'" title="'.$nws[1].'" align="left" /><br/>'.$testo;
}elseif($mod=="notizie"&&file_exists($nws[6])) {
$testo= '<img src="'.$nws[6].'" alt="'.$nws[1].'" title="'.$nws[1].'" align="left" /><br/>'.$testo;
}
$content = $sopra.$testo.$sotto;
		$html2pdf = new HTML2PDF('P','A4',$lng, false, $CharSet);
		$html2pdf->setDefaultFont('Arial');
		$html2pdf->writeHTML($content, false);
		$html2pdf->Output($oggetto.'.pdf');

?>